dpkg (1.9.0) unstable; urgency=low

  * Things should mostly work OpenBSD 2.8 as well now
  * Added a --status-pipe option.
  * Fixed several memleaks.
  * Profiled dpkg.
    * Reworked lib/parse.c:parsedb().  Instead of using getc(), then
      calling varbufaddc(), it now reads the entire file at once into a
      huge buffer, then moves pointers around, to do the parsing.  This
      gave a speedup of 33% on a dual celeron 333, when reading status and
      available.
    * various other speedups.
  * Removed all --smallmem code, as smallmem and largemem now actually
    use about the same amount of memory, and largemem is faster.  Both
    --largemem and --smallmem are now obselete options, and will print
    a warning if used. Closes: Bug#84905
  * Update German translation, Closes: Bug#80529,#80532,#87581
  * Update French translation, Closes: Bug#65284,#85035,#87238
  * Update Japanese translation, Closes: Bug#93873
  * Remove spurious '%s' in Polish translation, Closes: Bug#74814
  * Add French manpages, courtesy of Philippe Batailler
  * Ingore vim swapfiles in dpkg-source, Closes: Bug#81630
  * remove --import option from dpkg-statoverride, Closes: Bug#81358
  * Replace nfmalloc implementation with obstack. Added obstack.[ch] to
    optlib, for non-GNU systems.
  * dpkg-divert only allows absolute filenames now. Closes: Bug#82419
  * Handle diffs from non-existing files to existing files. Closes: Bug#82708,
    #90982.
  * Small fixes to the buildsystem. Closes: Bug#84361
  * Fix dpkg-statoverride --update for things other then plain files.
    Closes: Bug#84449
  * Fix race with source directory disappearing in dpkg-source.
    Closes: Bug#45511
  * Fix manpage for dpkg-gencontrol. Closes: Bug#84625
  * Add -n option for dpkg-gencontrol to specify a filename. Closes: Bug#75796
  * Use POSIX glob instead of regexp in debian/rules. Closes: Bug#83042,
    #84582
  * fix typo in usage message for dpkg-divert, Closes: Bug#85977
  * Use full path for argv[0] when calling scripts. Closes: Bug#68783
  * Add ia64 support to dpkg-architecture.
  * Minor script changes, Closes: Bug#87485
  * Stop dpkg-genchanges from complaining about missing packages
    when doing a source-only build. Closes: Bug#87571,#15644,#25496
  * Various dpkg-architecture cleanups. Closes: Bug#87505
  * Modify dpkg-architecture to handle gcc versions containing letters.
    Closes: Bug#83083
  * dpkg-buildpackage updates: Closes: Bug#87572,#85847
    + make -C work properly
    + fix test for gpg secret keyring
    + improve source messages
    + skip signing pause when building unsigned packages
    + test for invalid signinterface. Closes: Bug#87579
    + remove debsign support, it's useless and doesn't work
    + Use correct architecture when naming .changes file. Closes: Bug#88015
  * Fix wording in dpkg-statoverride manpage for --add. Closes: Bug#85080
  * Fix typo in start-stop-daemon manpage. Closes: Bug#88225
  * Add dpkg-checkbuilddeps to check if build dependencies are satisfied
    and modify dpkg-buildpackage to call it if wanted.
    Closes: Bug#86453,#83812,#60717,#74372,#67896,#60717,#13961
  * dpkg-parsechangelog can read a changelog from stdin now. Closes: Bug#80142
  * Fix confusing wording for dpkg-buildpackage -uc option in manpage.
    Closes: Bug#83468
  * dpkg-statoverride now exits with exitcode 1 if we do a --list but don't
    output anything. Closes: Bug#84328
  * Remove Linux reference from all scripts, they should run fine on
    other OSes as well.
  * Mark last argument in dpkg-scanpackages usage info as optional.
    Closes: Bug#86658
  * Fix cache in dpkg-scanpackages version comparison. Closes: Bug#90722
  * Fix formatting error in dpkg-source.1. Closes: Bug#82723
  * Change dpkg-gencontrol to fix comma-related syntax errors after
    processing substvars. Closes: Bug#92908
  * Verify package signatures if debsig-verify is installed. Closes: Bug#37017
  * Handle window resize in dselect main menu. Closes: Bug#93559
  * Initialize all parts of the package record.  This should fix several
    segfaults people have been seeing in dpkg.  Closes: Bug#90328.
  * Apply patch from bug#86847, that escapes intl chars in filenames.
    Closes: Bug#83752, #85040, #86847, #89000.
  * Errors during dpkg -s(and other similiar commands) are now printed
    on stderr.  Closes: Bug#88987.
  * Add a --retry option to start-stop-daemon. Closes: Bug#75139
  * Fix regeps to extract Closes magic from a changelog so the #
    is really optional. Closes: Bug#94474
  * Remove useless statement from dpkg-shlibdeps. Closes: Bug#90516
  * Make the debian changelog parser identify itself with $progname.
    Closes: Bug#89409
  * Give a syntax error when we get an unexpected PGP signature in control
    files. Closes: Bug#75562

 -- Wichert Akkerman <wakkerma@debian.org>  Sat, 13 Jan 2001 08:52:11 -0500

dpkg (1.8.3.1) unstable; urgency=low

  * Revert change to nfmalloc.c that was causing SIGBUS on sparc.

 -- Ben Collins <bcollins@debian.org>  Sat, 13 Jan 2001 08:52:11 -0500

dpkg (1.8.3) unstable; urgency=low

  * Do chown before chmod in dpkg-statoverride, Closes: Bug#81943
  * Fix recusion in dpkg-shlibdeps, Closes: Bug#81322
  * Really completely revert dpkg-source patches which broke backwards
    compatibility

 -- Wichert Akkerman <wakkerma@debian.org>  Fri, 12 Jan 2001 00:02:22 -0800

dpkg (1.8.2) unstable; urgency=low

  * Don't attempt to read from an input source when we only want 0 bytes.
    Also handle buggy systems that return EAGAIN instead of EINTR.  Closes:
    #81881.
 
 -- Adam Heath <doogie@debian.org>  Thu, 11 Jan 2001 00:43:50 -0600

dpkg (1.8.1.1) unstable; urgency=low

  * Apply patch from bug to fix badly generated diffs(in some
    circumstances).  Closes: #81152

 -- Adam Heath <doogie@debian.org>  Sat,  6 Jan 2001 16:07:33 -0600

dpkg (1.8.1) unstable; urgency=low

  * Make --name a valid option.  Closes: #31206, #51953.
  * dpkg-deb -I <pkg> <control> works again
  * Update Swedish translation

 -- Wichert Akkerman <wakkerma@debian.org>  Thu,  4 Jan 2001 19:31:13 +0100

dpkg (1.8.0) unstable; urgency=low

  * Add -k|--symlink option to dpkg-name.  Closes: #35040
  * Made the accelerator keys in dselect's main menu separate options, so
    that they can be translated separately.  Closes: #50955.
  * Added depends on sysvinit (>= 2.72), so that we can make sure that
    /etc/rcS.d exists.  Closes: #55037.
  * update-rc.d: Changed documentation and help, as -f only applies during
    remove.  Closes: #55049.
  * Added a --force-all option.  Closes: #61354.
  * Format help string for --abort-after like other option help strings.
    Closes: #62464.
  * Fix dselect methods to pass admindir to dpkg from dselect.
  * Minor tweak so that when patch 2.5.4 is manually used to apply a diff,
    it doesn't get applied multiple times.  Closes: #65021
  * Add --nicelevel to start-stop-daemon, to alter a programs priority
    before starting.  Closes: #65191.
  * Document that --largemem is the default, and that the test point is
    24 megs.  Closes: #65607.
  * Document that --set-selections does not actually install any
    packages.  Closes: #65340.
  * Fix typo in dpkg-deb.1.  Closes: #65945.
  * Add --truename option to dpkg-divert.  Closes: #68489.
  * Documented COLUMNS in dpkg(8).  Closes: #77001.
  * Modified DPKG_C_GCC_TRY_WARNS() to call AC_SUBST, so that we can
    use the result of the test during build time.  Closes: Bug#75138
  * Added description for "suggests" in main/depcon.c:describedepcon().
    Closes: Bug#74113
  * Removed bashing from dpkg.postinst.
  * Make '#' optional in Closes: tags.  Closes: Bug#63137.
  * Add -t to -h output in dpkg-buildpackage:  Closes: Bug#49598.
  * Fix typo in --compare-versions error message.  Closes: Bug#66474.
  * -R doesn't mean --root.  Closes: Bug#66068, #72013
  * Add armv3l to archtable.  Closes: Bug#72125
  * Fix two memory leaks, and lesson the memory foot print a tad.  Hints
    taken from 74259.
  * Fix some things perl5.6 complains about. Closes: Bug#77337
  * Fix referenes to dpkg-deb manpage. Closes: Bug#77855
  * Update Galish translation
  * Add new --import option to dpkg-statoverride to make it easy to
    import suidmanager settings.
  * Speedup patches by Adam Heath
  * statoverride fixes by Robert Luberda, Closes: Bug#78436
  * Add Linux S/390 support. Closes: Bug#79063
  * Using libz to decompress data instead of calling gzip.
    Closes: Bug#49581
  * Add gettext to build-depends
  * Fix warning when trying to remove a non-existing statoverride.
    Closes: Bug#79352
  * Be more paranoid with file permissions when extracing files
  * Apply statoverrides to more then just files
  * Update update-alternatives manpage to use FHS instead of FSSTND.
    Closes: Bug#80237
  * List descriptions for udebs in .changes

 -- Wichert Akkerman <wakkerma@debian.org>  Mon, 25 Dec 2000 17:19:31 +0100

dpkg (1.7.2) unstable; urgency=low

  * Fix parsing of configuration files
  * Add new powerpc-linux-gnu entry to archtable. Closes: Bug#76522
  * No longer bother to install emacs things. I don't use emacs myself
    and can't support that properly.
  * scripts/dpkg-shlibdeps.pl: Make it parse soname's in the format of
    "libfoo-X.X.so" (e.g. libdb-3.1.so) and use it. Also make it give a
    warning if there is a NEEDED line in the objdump output that we cannot
    grok.
  * scripts/dpkg-shlibdeps.pl: resolve library paths using a combination
    of the libc major version, and ldconfig -p output. Solves problems
    with errant libc5 deps.
  * Correct name of .changes file when doing source-only builds
  * Fix -ap option for dpkg-buildpackage. Closes: Bug#77305
  * Fix typo in update-alternatives manpage. Closes: Bug#77829
  * Fix typo in script-regexp update-rc.d. Closes: Bug#76029

 -- Wichert Akkerman <wakkerma@debian.org>  Thu, 23 Nov 2000 18:55:50 +0100

dpkg (1.7.1) unstable; urgency=medium

  * Fix a typo in the dpkg-statoveride manpage
  * dpkg-statoverride reads and writes the right file now
  * Make update-alternatives use the right dir for alternatives again

 -- Wichert Akkerman <wakkerma@debian.org>  Tue,  7 Nov 2000 01:16:39 +0100

dpkg (1.7.0) unstable; urgency=low

  * Allow the administrator to override file mode and ownership using the
    new dpkg-statoverride tool.
  * Use objdump instead of ldd in dpkg-shlibdeps
  * Fix logic in dpkg-shlibdeps so it looks for dependencies as specified
    in its documentation
  * Make update-alternatives update slave links with --config and properly
    switch the alternative to manual mode
  * HURD updates, Closes: Bug#57753,#57754,#57755
  * dpkg-architecture: -q should not imply -f, Closes: Bug#57761
  * add dpkg:UpstreamVersion and dpkg:Version substvars in dpkg-genchanges
    and dpkg-gencontrol.  Closes: Bug#62069,#64774
  * dpkg-genchanges: add new Changed-By field to .changes with the last
    person who made a change, and modify the Maintainer-field to be the
    actual maintainer. Update the format-version to 1.7 to reflect this.
  * dpkg-genchanges: allow a space between # and a to-be-closed bugnumber
  * dpkg-deb: reorder files when building a package
  * dpkg-statoverride: new tool to override ownership and modes for files
  * Check COLUMNS environment for dpkg -l output. Closes: Bug#65536
  * Add Origin and Bugs fields to the control file
  * Install new /etc/dpkg/origins/debian file
  * Corrections and updates to Swedish translation.
  * Add Galician, German, Dutch and Brazilian translations
  * archtable: add ia64 and sh; revert sparc64 so that it turns into sparc.
    There wont be a full binary-sparc64 port. Closes: Bug#70788
  * dselect/main.cc: small fixups to get it to compile with gcc-2.96
  * Clean up fd handling in some places. Closes: Bug#69359,#69360,#69361
  * Document -k option for dpkg-buildpackage. Closes: Bug#71808
  * Install commented dummy shlibs.default and shlibs.override files
  * Give dpkg a configurationfile
  * dpkg-scanpackages now uses the most recent version if multiple versions
    of a package are found.
  * don't rename a file to itself in dpkg-source. Closes: Bug#75060
  * Fix buffer overflow in cmdname handling in start-stop-daemon.
    Closes: Bug#75103
  * Don't abort if start-stop-daemon tries to read a non-existing pidfile.
    Closes: Bug#75105
  * Update formating of start-stop-daemon manpage. Closes: Bug#75110
  * Make a missing package a warning instead of an error in dpkg-genchanges

 -- Wichert Akkerman <wakkerma@debian.org>  Sun,  5 Nov 2000 17:28:39 +0100

dpkg (1.6.13) frozen unstable; urgency=low

  * Add Format-flag to .dsc format: we know we are going to change the
    format in the next release, this change will make dpkg-source abort
    with a reasonable error instead of doing unexpected things.
  * Fix error in gettext'ized string
  * Updated Czech, French, Polish and Spanish translations. Closes: Bug#63663
  * debian-changelog-mode.el: fix documentation string for
    debian-changelog-finalise-last. Closes: Bug#63003

 -- Wichert Akkerman <wakkerma@debian.org>  Mon,  8 May 2000 16:08:53 +0200

dpkg (1.6.12.99) frozen unstable; urgency=low

  * Pre-release for 1.6.13. which will only feature translation updates
  * Fix typo in dpkg-divert, Closes: Bug#60243
  * dpkg-genchanges: recognize non-deb packages (tarballs, such as
    dpkg-non-deb and boot-floppies disk tarballs). This makes sure that we
    include them when figuring out the Arch field in the .changes
  * mark another string as translateable, Closes: Bug#62543
  * fix location of --abort-after in --help output, Closes: Bug#62464
  * fix allocation error in checkpath(), Closes: Bug#62364
  * add Hold to list of desired package states in -l output, Closes: Bug#58765

 -- Wichert Akkerman <wakkerma@debian.org>  Fri, 21 Apr 2000 11:52:59 +0200

dpkg (1.6.12) frozen unstable; urgency=high

  * Fix test for gpg/pgp in dpkg-buildpackage. You can now build
    unsigned packages again. Closes: Bug#60395
  * Updated Spanish and Swedish translations. Closes: Bug#41735
  * Merge patch from Joel Klecker to remove emacsen-common stuff from dpkg-dev

 -- Wichert Akkerman <wakkerma@debian.org>  Mon,  3 Apr 2000 16:50:02 +0200

dpkg (1.6.11) frozen unstable; urgency=high

  * Oops, missed one case where the libc/ncurses conflict reared its
    ugly head and broke dselect miserably. 
  * fix syntax error in dpkg-divert. Closes: Bug#60050

 -- Wichert Akkerman <wakkerma@debian.org>  Fri, 10 Mar 2000 11:52:07 +1100

dpkg (1.6.10) frozen unstable; urgency=low

  * The `it rains in Sydney' release
  * Mark another string in dselect as translateable, Closes: Bug#58618
  * Fix typos, Closes: Bug#58619
  * Change dselect keybindings slightly so `n' really does searchagain
  * Updated Czech and Spanish translations, Closes: Bug#58617
  * dpkg-divert.pl: reinstate last writeability-patch. Modified
    to not abort on ENOENT: this indicates a directory does not (yet)
    exist. If this happens don't try to rename. This should fix all
    current dpkg-divert problems. Closes: Bug#59207,#58596
  * update-alternatives: switch back to auto-mode when manually selected
    alternative is removed, Closes: Bug#54933
  * dselect no longer segfaults on SIGWINCH but does The Right Thing
    instead. Closes: Bug#54303,#58697,#59419

 -- Wichert Akkerman <wakkerma@debian.org>  Tue,  7 Mar 2000 15:09:47 +1100

dpkg (1.6.9) frozen unstable; urgency=low

  * Fix typo in update-alternatives manpage
  * dpkg-architecture: -q should not imply -f, Closes: Bug#57761
  * Cleanup bits of install-info to make it more stable
  * Fix Build-Dependency for ncurses, Closes: Bug#58073
  * Some more documentation updates, Closes: Bug#57985
  * Revert patch to check for writeable filesystems in dpkg-divert,
    Closes: Bug#57840

 -- Wichert Akkerman <wakkerma@debian.org>  Fri, 18 Feb 2000 12:11:58 +0100

dpkg (1.6.8) frozen unstable; urgency=low

  * Turn --force-overwrite on by default
  * Fix a couple of small buildsystem errors
  * Support multiple adjacent newlines in control-style files, Closes: Bug#56056
  * Updated Czech and Swedish translations
  * Revert patch to change order of things when purging a package,
    Closes: Bug#56374
  * Handle failed open of /dev/tty in dpkg -l, Closes: Bug# 55041
  * Update Japanese translations, Closes: Bug# 56641, #57494, #57595
  * Update extended description for dpkg-dev, Closes: Bug# 56675
  * Implement verbose option for update-alternative
  * Fix conflicts handling

 -- Wichert Akkerman <wakkerma@debian.org>  Thu, 10 Feb 2000 15:31:31 +0100

dpkg (1.6.7) frozen unstable; urgency=low

  * dpkg compiles on HP-UX, Solaris and IRIX now
  * start-stop-daemon can chroot now, Closes: Bug#54513
  * Allow space between # and the bugnumber in the changelog
  * Display package description with waddnstr, Closes: Bug#54313
  * Updated Japanese manpages, Closes: Bug#54690, #55080
  * Upload full source for packages with version *-0.1, Closes: Bug#54651

 -- Wichert Akkerman <wakkerma@debian.org>  Sun, 16 Jan 2000 18:36:10 +0100

dpkg (1.6.6) unstable; urgency=low

  * dpkg-buildpackage supports debsign, Closes: Bug#58333
  * fix update-alternatives manpage, Closes: Bug#53859
  * Updated Polish translation
  * Pass admindir to dpkg, Closes: Bug#54039
  * Fix dpkg -l output
  * Remove dpkg-safelist again, it had issues

 -- Wichert Akkerman <wakkerma@debian.org>  Fri,  7 Jan 2000 19:51:45 +0100

dpkg (1.6.5) unstable; urgency=low

  * Update Spanish translation
  * Don't strip 8th bit in dselect packagelists, Closes: Bug# 49061
  * Don't use \z in dpkg-scansources, Closes: Bug# 53182
  * Correctly unregister internals manual, Closes: Bug# 53200
  * dselect helpessages can be translated now, Closes: Bug# 51381
  * dselect UI tweaks, including a new --expert mode
  * Added build-depends, Closes: Bug# 53394
  * Added THANKS-file with people who have contributed to the code
  * Use full width of tty in packagelisting, Closes: Bug# 53395
  * Add -z option to dpkg-deb to set compressionlevel when building
    packages, Closes: Bug# 53398
  * Fix segfaults when producing a diff between current and new conffile,
    Closes: Bug# 52197

 -- Wichert Akkerman <wakkerma@debian.org>  Sat, 25 Dec 1999 04:47:09 +0100

dpkg (1.6.4) unstable; urgency=low

  * No longer byte-compile for emacs
  * Add Swedish translation
  * start-stop-daemon: honour --oknodo if we fail to kill a process
    Closes: Bug#52580,#52185,#52457
  * Fix dselect program description, Closes: Bug#52328
  * Fix architecture-detection in dpkg-gencontrol, Closes: Bug#52616
  * Accept single-number values in update-rc.d, Closes: Bug#46810

 -- Wichert Akkerman <wakkerma@debian.org>  Sun, 19 Dec 1999 16:27:48 +0100

dpkg (1.6.3) unstable; urgency=high

  * Comment dselect changes from 1.6.2, they seem to have a problem
    Closes: #52043,52058,52088,51437
  * Really fix emacs-stuff. Hopefully. Closes: #51919,51525
  * Fix copyright display in dselect menu, Closes: #52093
  * Fix uid/gid-changes in start-stop-daemon, Closes: #52081

 -- Wichert Akkerman <wakkerma@debian.org>  Tue,  7 Dec 1999 17:06:00 +0100

dpkg (1.6.2) unstable; urgency=low

  * New dpkg-scansources, Closes: #51888
  * Fix default for elispdir, Closes: #51919,51525
  * New manpages for cleanup-info and dpkg-divert, Closes: #51539, 46657
  * Buildsystem updates, Closes: #51525, 51855, 51914
  * Modify dselect behaviour for suggests and recommends

 -- Wichert Akkerman <wakkerma@debian.org>  Sun,  5 Dec 1999 19:29:50 +0100

dpkg (1.6.1) unstable; urgency=low

  * Fix some slight packaging errors

 -- Wichert Akkerman <wakkerma@debian.org>  Fri, 26 Nov 1999 20:18:48 +0100

dpkg (1.6) unstable; urgency=low

  * Major overhaul of the buildsystem
  * Update Standards-Version to 3.1.0
  * Move to version 1.6 to reflect the amount of changes made
  * Fix mixup with Czech and Polish translations, Closes: Bug# 48986
  * utils/start-stop-daemon.c: Added ability for user.group arg to
    --chuid. Also, always call initgroups() when using --chuid.
  * utils/start-stop-daemon.8: Document above change, also add note to the
    --make-pidfile option concerning its problem with daemons that fork

 -- Wichert Akkerman <wakkerma@debian.org>  Thu, 25 Nov 1999 04:30:01 +0100

dpkg (1.4.1.19) unstable; urgency=low

  * Fix replaces for dpkg-dev
  * Add gettext-support to dselect
  * Added Czech and Polish translations for dpkg
  * Fixed incorrect patch for --print-architecture (oops, oh well
    it was already broken when there was no gcc anyway :)
  * Fixed missing mipseb that was supposed to be in the archtable
  * Better output in update-alternatives --config, now shows the
    current, and the prefered choices.
  * dpkg-name: ignore epoch when getting version
  * 50dpkg-dev.el: add it as a conffile for dpkg-dev
  * internals.sgml: Removed references to the versions of build tools,
    they date the document.
  * debian-changelog-mode.el: added hint for better log-email handling
  * Added recognition for new source-depends fields for policy
    referenced in bug #41232
  * dpkg-buildpackage: add -ap option to force a pause prior to starting
    the sign process. This helps for people who don't keep their signatures
    on the filesystem (on a floppy perhaps, then mount as needed).
  * minor script corrections
  * dpkg-dev control: Change gcc to c-compiler in the recommends field, and
    move cpio, patch and make to the depends line
  * Leave file info intact in available when installing packages. MD5sum,
    Filename, and MSDOS-Filename used to get lost when installing a
    package.
  * Added armv4l to archtable
  * Added 'D' to the list of choices for conffile handling, closes: #48137
  * Converted internals.sgml to debiandoc format. Also added a dpkg-doc
    package that contains the generated output from this file (.ps, .html
    and .info), includes doc-base support. Internals.sgml is also not
    generated on the binary-arch target, and is no longer "byhand"
  * dpkg-gencontrol: add "Source" to the fields placed in the control file
  * dpkg-parsechangelog: fixed loop for parsepath (#48526)
  * main/{processarc.c,depcon.c}: added new structure for conflictors,
    which contains a struct for conflicts. This is used to create an array
    of conflicting packages, which are going to be replaced. Allows for
    multiple conflicts and replaces. All conflictor handlers were
    converted to loops to handle each one (processarc.c).
  * dpkg-divert: Fix check for writable filesystem, closes: #48646

 -- Wichert Akkerman <wakkerma@debian.org>  Sat, 30 Oct 1999 15:14:40 +0200

dpkg (1.4.1.18) unstable; urgency=low

  * Backout dep check patch

 -- Ben Collins <bcollins@debian.org>  Sat, 23 Oct 1999 00:39:24 -0400

dpkg (1.4.1.17) unstable; urgency=low

  * Add support for long filenames, along with --assert-longfilenames
  * Added --chuid option to start-stop-daemon to allow switching to
    a different uid when starting a process
  * Add mipseb and mipsel to the archtable too, since mips and mipseb are
    both viable names for the mips big endian arch, and mipsel is also needed
  * Update dpkg-architecure's archtable
  * Added --config option to update-alternatives to allow easy changing
    of the registered alternatives for a specific name
  * Updated the deb-control(5) man page with all the current fields
    and uses
  * Made the large info screen show 5 lines of the pkglist so that
    it scrolled properly, and still showed the cursor in dselect
  * Removed references to dpkg(5) which seems to not exist anymore
  * Fixed `dpkg-deb --help' and dpkg-deb(1) from reporting --no-check
    when it's actually --nocheck (went with the hardcoded option, so
    this is just a documentation fix).
  * Added better check in disk.setup for a working NFS server. Makes
    it compatible with other non-Linux servers.
  * Corrected dpkg(8)'s example of using dpkg -i (showed it used with
    a .tar.gz instead of a .deb)
  * Applied patch to correct improper TMPDIR handling in dpkg-deb
  * When encountering an error in extracting the tar archives in the
    packages, we should abort the install, not simply give an error
    and continue.
  * Make dpkg give the builtin arch if there was an error while exec()'ing
    the C compiler with --print-architecture. We still fail if the
    output from gcc was bad in some way, since they may be of importance.
  * Removed the maintainer-configure portion in debian/rules, since
    we should be shipping the source with all the auto* stuff
    already generated anyway
  * Removed the ltconfig patch, and resort to a debian/rules fix
    to libtool itself after running configure
  * Removed shlibs.default.i386. It's now a template for arch porting to
    Debian/dpkg, we install it still, if there exists a file matching the
    arch
  * Reimplemented a better *stat cache for the removal checking code,
    this helps a lot when doing upgrades where the packages are a lot
    different in layout
  * Increased largemem auto detection to >= 24megs, since it's not uncommon
    for dpkg to actually use 16megs of ram all on its own when using the
    largemem setting (old minimum was 16megs)
  * debian/rules: chmod -x everything in /usr/lib to make lintian happy.
    in the clean phase just rm -rf $(BUILD), we don't need to run
    distclean and all that other stuff. Don't run "make dist", we
    simply copy the .tar.gz that dpkg-source creates for the byhand
    source.
  * Make start-stop-daemon exit(1) when we don't find one of the
    pid's we are trying to kill, in accordance with the man page.
  * When running --configure on an already installed package, just
    say it's installed, and not that it is in an unconfigurable
    state
  * Fixed some compiler warnings
  * Make dpkg check for uid 0 requirement, before checking the path
    since not being root, is probably the reason that the PATH is
    borked in the first place
  * Make -p short for --print-avail, and -P short for --purge
  * Fix typo in md5sum(1) man page
  * start-stop-daemon: Add --background and --make-pidfile options
  * update-alternatives: make sure we remove "old" symlinks when they
    are no longer pertinent. Add /etc/alternatives/README that refers
    to the update-alternatives(8) man page.
  * dpkg-divert: Add check for being able to write to the old/new
    destination before doing a rename. We fail on this, without
    changing the diversion registry
  * Fix bad regex in update-rc.d

 -- Wichert Akkerman <wakkerma@debian.org>  Thu, 21 Oct 1999 17:49:03 +0200

dpkg (1.4.1.16) unstable; urgency=medium

  * Hardcode ENOENT again since the errno-part of the POSIX module
    isn't in perl-*-base. sigh.

 -- Wichert Akkerman <wakkerma@debian.org>  Fri, 15 Oct 1999 04:01:14 +0200

dpkg (1.4.1.15) unstable; urgency=low

  * non-maintainer release.
  * Move dselect into its own package
  * Remove conffiles before directories when purging
  * Check if integrity from other packages will broken when processing
    an archive
  * dpkg-deb can handle package made with Linux ar.
  * Add check to update-alternatives to see if the sequencecode is between
    0 and 99
  * Fix failed assertion, which was actually two bugs: a logic error in
    checkforremoval and a wrong assumption in findbreakcycle
  * dselect doesn't die when you resize the terminal
  * check if a file is also in a new package before removing it when upgrading
  * offer to show a diff between the old and new conffile
  * dpkg-scanpackages: don't abort but only skip a package if we can't
    open it
  * Add HURD-support to  start-stop-daemon
  * Reinstate patch to not read available when doing --list-files
  * Add a couple of --force options to handle changed conffiles

 -- Wichert Akkerman <wakkerma@debian.org>  Thu, 14 Oct 1999 04:20:56 +0200

dpkg (1.4.1.14) unstable; urgency=low

  * non-maintainer release.
  * dpkg-source works again on empty diffs, Closes: Bug# 46159
  * Install locale-files in /usr/share, Closes: Bug# 46631
  * Make /usr/share/doc/dpkg-dev a symlink to /usr/share/doc/dpkg
  * Actually include fix to make update-alternatives works filesystems (oops!)
  * Check if codenumber is between 0 and 99, Closes: Bug# 46810

 -- Wichert Akkerman <wakkerma@debian.org>  Tue,  5 Oct 1999 19:19:05 +0200

dpkg (1.4.1.13) unstable; urgency=low

  * Non-maintainer release.
  * NMU number 13, lets see what breaks :)
  * update-alternatives works across filesystems now
  * Make -sgpg work in dpkg-buildpackage (typo)

 -- Wichert Akkerman <wakkerma@debian.org>  Tue, 28 Sep 1999 01:26:19 +0200

dpkg (1.4.1.12) unstable; urgency=low

  * Non-maintainer release.
  * Fix typo in chmodsafe_unlink that made dpkg chmod files that
    weren't setuid or setgid

 -- Wichert Akkerman <wakkerma@debian.org>  Sun, 26 Sep 1999 02:41:30 +0200

dpkg (1.4.1.11) unstable; urgency=low

  * Non-maintainer release.
  * Added sparc64 to archtable
  * Added entries for newer alpha architectures to the archtable
  * Always run patch and diff with LANG set to C.
  * Handle diff warning for files with no newline at the end of file
    Closes: Bug#45642

 -- Wichert Akkerman <wakkerma@debian.org>  Fri, 24 Sep 1999 03:23:54 +0200

dpkg (1.4.1.10) unstable; urgency=low

  * Non-maintainer release.
  * Build dpkg-scansources manpages using pod2man
  * dpkg-buildpackage changes:
    + fix signinterface-detection
    + use gpg by default if $HOME/.gnupg/secring.gpg exists

 -- Wichert Akkerman <wakkerma@debian.org>  Thu, 16 Sep 1999 15:36:43 +0200

dpkg (1.4.1.9) unstable; urgency=low

  * Non-maintainer release.
  * Updated dpkg-scansources to current version from Roderick Schertler
  * Update location of GPL in internals-manual
  * Update location of GPL and dpkg copyright in all manpages
  * Include patch from Roman Hodek for dpkg-source to handle diffs of files
    with lines that begin with two dashes.
  * Move dpkg-scansources to dpkg-dev package
  * Move dpkg-scansources manpage to section 8
  * Fix error that moved a lot of manpages to the dpkg package.
  * It looks like not reading the available-file for listfiles was not greeted
    with much enthiousiasm, so reverse the change.

 -- Wichert Akkerman <wakkerma@debian.org>  Wed, 15 Sep 1999 03:45:07 +0200

dpkg (1.4.1.8) unstable; urgency=low

  * Non-maintainer release.
  * Merge dpkg-doc-ja
  * Add patch from Raphael Hertzog <rhertzog@hrnet.fr> for dpkg-scansources
    to skip comments in signatures. This allows packages to also use GnuPG.

 -- Wichert Akkerman <wakkerma@debian.org>  Mon, 13 Sep 1999 04:16:33 +0200

dpkg (1.4.1.7) unstable; urgency=low

  * Non-maintainer release.
  * Use /usr/share/doc
  * Merge changes from dpkg-iwj tree:
    + change section in dpkg-deb.1 to 1
    + Use COPYINGFILE instead of hardcoded GPL-location in showcopyright()
    + varbufprintf (used for some error messages) vsnprintf return value
      assumption changed to correspond to reality rather than glibc-doc.
    + Don't read available-info when not needed (slightly improved from 
      dpkg-iwj: don't read for listfiles either :)
    + Cleanup --assert-* code
    + Assume largemem on systems without sysinfo(2).
    + modify preexec-script for easier script execution
    + Do not chmod(".../path/to/symlink",0600) causing many bad perms.
    + Sanity-check numbers for parameters
    + Move some logic from process_archive into wantinstall
    + Print '0' in dpkg-scanpackages if no packages found.

 -- Wichert Akkerman <wakkerma@debian.org>  Fri, 10 Sep 1999 04:06:32 +0200

dpkg (1.4.1.6) unstable; urgency=low

  * Non-maintainer release.
  * scripts/dpkg-architecture.pl: Update to latest version.
  * scripts/dpkg-architecture.1: Likewise.
  
 -- Marcus Brinkmann <brinkmd@debian.org>  Sat, 24 Jul 1999 18:24:21 +0200

dpkg (1.4.1.5) unstable; urgency=low

  * Non-maintainer release.
  * (dpkg-dev): Use emacsen-common for debian-changelog-mode.el
    (closes:Bug#20776,#31030).
  * Removed references to the packaging and policy manuals from debian/control.
  * Put debian-changelog-mode.el in dpkg-dev and remove from dpkg (closes:Bug#29271).
  * Fix paths in 50dpkg-dev.el using Roderick Schertler's patch
    (closes:Bug#28270,#29702,#26876,#29184,and others).
  * Note that bug number 17367 was fixed in 1.4.0.26.
  * Add Zack Weinberg's install-info patch for GNU install-info
    compatibility (closes:Bug#28965).
  * Add dpkg-architecture stuff from Marcus Brinkmann.
  * Remove debian-keyring suggests from dpkg.
  * Add -k<keyid> flag to dpkg-buildpackage.
  * --textmode works in gpg, remove kluge from dpkg-buildpackage.
  * Cleanup configure.in slightly (stop using tl_ macros, fix gettext stuff).
  * Attempt to make Debian source useful for non-Debian systems
    (i.e. distclean tree instead of maintainer-clean tree).
  * Sync with wichert's 1.4.1.4.
  * Add my ltconfig-1.3.2.diff (RPATH workaround).
  * Add dpkg-scansources program and man page.
  * Man pages in /usr/share/man.

 -- Joel Klecker <espy@debian.org>  Tue, 13 Jul 1999 18:12:15 -0700

dpkg (1.4.1.4) unstable; urgency=low

  * Also change developer-keyring to debian-keyring for dpkg-dev package
  * Include spanish translation from Nicolás Lichtmaier <nick@debian.org>
  * Depend on perl5 instead of perl

 -- Wichert Akkerman <wakkerma@debian.org>  Mon,  5 Jul 1999 00:04:14 +0200

dpkg (1.4.1.3) unstable; urgency=low

  * Modify tarobject() so it does not complain if we are creating a
    directory that replaces a removed file. This works around the
    problem that the filedatabase doesn't remember what filetype a
    file was by assuming it already was a directory

 -- Wichert Akkerman <wakkerma@debian.org>  Mon, 31 May 1999 23:49:23 +0200

dpkg (1.4.1.2) unstable; urgency=low

  * Non-maintainer upload
  * Rebuild, so this is glibc2.1 (unless you're on m68k), which is rumoured
    to also fix the i8n-problems.
  * Incorporate 1.6 format of .changes, patch from Guy Maor
  * Fix bug in section-handling of dpkg-scanpackages, patch from Guy Maor
  * Disable force-overwrites again, since we're in unstable
  * Assume largemem on systems for which sysinfo is not available, Bug# 33658

 -- Wichert Akkerman <wakkerma@debian.org>  Wed, 26 May 1999 15:50:17 +0200

dpkg (1.4.1.1) unstable; urgency=low

  * Non-maintainer upload
  * Install emacs-startup scripts with mode 0644 (lintian)
  * Incorporate changes in NMU 1.4.0.32 made by Vincent Renardias
    <vincent@waw.com> for slink:
    + Apply patch from Jim Pick for update-alternatives.pl to
      fix 'Important' bugs #30891 in dpkg and (#27382, #27383, #27696,
      #27703, #27736, #27097(merged bugs)) in jdk1.1.
  * Incorporate changes in NMU 1.4.0.33 made by me for slink:
    + Fix illegal perl construct (Bug# 30985)
    + Initialize oialtname->useinstead and oicontest->camefrom to 0 (Bug# 30397)
    + Update shlibs.default for libncurses 4 (Bug# 30332)
    + Suggest debian-keyring instead of developer-keyring (Bug# 27376, 30248)
    + Abort dpkg-divert when attempting to divert a directory (Bug# 30126)
    + Make dpkg-deb.1 aware that it is in section 1, not 8
    + Fix section in reference to dpkg-deb in dpkg.8 (Bug# 29740)
    + Fix typo in --force-help (Bug# 26193)
    + Correct path for debian-changelog-mode.el (Bug# 24606)
    + Make disk-method for dpkg use /var/run instead of /tmp to fix
      symlink-attacks (Bug# 21399)
    + Document -n and -f options for update-rc.d in manpage (Bug# 15913)
    + Add --abort-after option to change after how many errors we abort and
      change the default to 50 (Bug# 22940)
    + Fix controllib.pl: don't check debian/substvars unless needed, and
      don't depend on language settings (Bug# 31508)
    + Allow a - in the architecture-field (Bug# 25537)

 -- Wichert Akkerman <wakkerma@debian.org>  Mon,  1 Feb 1999 00:44:01 +0100

dpkg (1.4.1) unstable; urgency=low

  * Maintainer release by IWJ.
  * Changed Maintainer: field description.
  * Various changes to make the damn thing build.
  * Add .cvsignore files.

 -- Ian Jackson <ian@davenant.greenend.org.uk>  Sun,  1 Nov 1998 17:33:38 +0000

dpkg (1.4.0.31) unstable; urgency=low

  * dpkg/processarc.c: Make newfileslist static like the other arguments
    for register_cleanup's cu_* functions.
  * N-th fix for controllib.pl (simulate old behavior by trying stdin,
    stdout, and stderr for getlogin()).
  * Enable --force-overwrite for slink release, and comment where to do
    so (dpkg/main.c).
  * Recompile against ncurses4.

 -- Daniel Jacobowitz <dan@debian.org>  Thu, 22 Oct 1998 17:37:23 -0400

dpkg (1.4.0.30) unstable; urgency=low

  * dpkg-dev isn't allowed to have a Recommends: debian-keyring (as that's
    in contrib), so it's now lowered to a Suggests: . Thanks to James Troup
    for pointing this out. 

 -- J.H.M. Dassen (Ray) <jdassen@wi.LeidenUniv.nl>  Sat, 26 Sep 1998 13:59:23 +0200

dpkg (1.4.0.29) unstable; urgency=low

  * For now, prefer PGP over GPG.

 -- J.H.M. Dassen (Ray) <jdassen@wi.LeidenUniv.nl>  Tue, 22 Sep 1998 09:38:09 +0200

dpkg (1.4.0.28) unstable; urgency=low

  * Added gpg (GNU Privacy Guard) support:
    * scripts/buildpackage.sh: default to GPG (unless no GPG, but only a PGP
      secret key file is found), as GPG, unlike PGP, is DFSG-free.
    * Updated dpkg-source(1), and added gpg(1) and pgp(1) to the SEE ALSO
      section.
    * Worked around broken textmode implementation in GPG.
    * dpkg-dev now Suggests: gnupg .
  * No longer includes developer-keys.pgp . Instead, dpkg now Suggests: and
    dpkg-dev now Recommends: developer-keyring.
  * Compiled with latest libstdc++ (2.9).

 -- J.H.M. Dassen (Ray) <jdassen@wi.LeidenUniv.nl>  Mon, 21 Sep 1998 13:17:14 +0200


dpkg (1.4.0.27) unstable; urgency=low

  * REALLY fixed dpkg-dev, and new attempt to placate installer on internals.

 -- Daniel Jacobowitz <dan@debian.org>  Fri, 27 Jul 1998 15:58:04 -0400

dpkg (1.4.0.26.0.1) unstable; urgency=low

  * Binary-only upload for x86 and fixed dpkg-dev

 -- Daniel Jacobowitz <dan@debian.org>  Fri, 24 Jul 1998 15:58:04 -0400

dpkg (1.4.0.26) unstable; urgency=low

  * Non-maintainer upload.

  * Make --root work with maintainer scripts (Patch by Scott Barker,
    bugs #4863 and #3170).
  * Fix $(lispdir) bug if compiling without emacs (noticed by Joey Hess).

 -- Daniel Jacobowitz <dan@debian.org>  Thu, 23 Jul 1998 12:02:04 -0400

dpkg (1.4.0.25) unstable; urgency=low

  * Non-maintainer upload.
  
  * Add the requested -nc option to dpkg-buildpackage (Do
    not clean source tree, useful in debugging cycles).
  * controllib.pl: Again by popular acclamation, fix the getlogin() warnings.
    I redirected STDERR onto fd 0 before calling getlogin().
  * tools.m4: Fix display of whether c++ works.
  * dpkg-deb/extract.c: glibc 2.1 and some kernels want to make
    fflush() move the current fpos.  Until someone can fix that,
    protect with seek.
  * Add an extra 0, to dselect/{pkg,meth}keys.cc so it compiles again.
  * Start using lchown() if available.
  * Really fix #20353. (aclocal.m4 was the wrong place; that's a generated
    file.  The correct place is in tl_canon.m4.)

 -- Daniel Jacobowitz <dan@debian.org>  Tue, 21 Jul 1998 03:14:14 -0400

dpkg (1.4.0.24) unstable; urgency=low

  * Non-maintainer upload.

  * dpkg/main.c: Turn --force-overwrite off as default.
  * dpkg/main.c: don't list --force-overwrite as default in --force-help,
    noticed by Peter Weiss <Peter.Weiss@Informatik.Uni-Oldenburg.DE> and
    others. [#23542, part of #17409].
  * dpkg/dpkg.8: replaced with a newer version from Jim Van Zandt
    <jrv@vanzandt.mv.com>. [#21061]

  * dpkg-deb/build.c (do_build): add missing \n and improve error message
    when conffile name is too long. [#7057]

  * scripts/update-alternatives.8: replaced with better man page from
    Charles Briscoe-Smith <cpb4@ukc.ac.uk>. [#17283]
  * scripts/dpkg-source.1: corrected logic error in documentation for
    dpkg-gencontrol's -p option, as noticed by Oliver Elphick
    <olly@linda.lfix.co.uk>. [#14655]
  * scripts/controllib.pl (findarch): correct typo in error message,
    noticed by Yann Dirson <ydirson@a2points.com>. [#22106]
  * scripts/dpkg-buildpackage.sh: fix typo s/source version/source
    maintainer/, noticed by Joey Hess <joey@kite.ml.org>, Adam P. Harris
    <apharris@onshore.com> and others. [#10175, #15559]
  * scripts/dpkg-genchanges.pl: applied patch from Roman Hodek
    <Roman.Hodek@informatik.uni-erlangen.de> which solves problems with
    architecture specific packages in mostly architecture independent
    multi-binary source packages. [#14341, #20192].

  * doc/Makefile.am: remove any reference to the packaging manual, as it is
    now provided by the separate "packaging-manual" package.
  * doc/packaging.sgml: removed.
  * doc/developer-keys.pgp: updated to the current debian keyring.

  * aclocal.m4: applied patch from Joel Klecker <jk@espy.org> to handle
    egcs' --print-libgcc-file-name output. [#20353]
  
  * debian/copyright: correct FSF address.
  * debian/rules: add code from lesstif's debian/rules to make libtool
    less of a fool (i.e. not use -rpath and to link shared libraries
    against libraries it depends on).  Code by Richard Braakman
    <dark@xs4all.nl> and Yann Dirson <dirson@debian.org>.
  * debian/rules: remove all reference to the packaging manual as it is
    now provided by the seperate "packaging-manual" package. [#21581,
    #21186, #22698, #23342]
  * debian/rules: link dpkg-divert.1.gz to undocumented.7.gz as the lack
    of a real manpage has been reported in #11093.
  * debian/README.compile: removed gawk and bogus comment about gettext
    being in experimental, as reported by Santiago Vila <sanvila@unex.es>
    [#23344].  Added libpaperg (debiandoc2ps needs paperconf).
  * debian/shlibs.default.i386: updated for glibc, reported by Herbert Xu
    <herbert@gondor.apana.org.au>. [#13140]
  * debian/control (dpkg-dev): depend on perl as POSIX (not a part of
    perl-base) is needed by most of the perl dpkg-* scripts, noticed by
    Joel Klecker <jk@espy.org>. [#22115]

 -- James Troup <jjtroup@comp.brad.ac.uk>  Wed, 24 Jun 1998 14:38:52 +0200

dpkg (1.4.0.23.2) frozen unstable; urgency=low

  * Non-maintainer upload.
  * dpkg/main.c: Turn --force-overwrite back on as default.

 -- James Troup <jjtroup@comp.brad.ac.uk>  Tue, 23 Jun 1998 22:19:26 +0200

dpkg (1.4.0.23.1) frozen unstable; urgency=low

  * No real changes, only a new version code to make this go to frozen too.

 -- Nils Rennebarth <nils@debian.org>  Wed, 10 Jun 1998 17:29:58 +0200

dpkg (1.4.0.23) frozen unstable; urgency=low

  * Non-maintainer bug-fix release
  * Update the disk method to the hamm directory structure (Bug#21000)

 -- Nils Rennebarth <nils@debian.org>  Sun,  7 Jun 1998 19:14:51 +0200

dpkg (1.4.0.22) frozen unstable; urgency=medium

  * Non-maintainer bug-fix release
  * Install main changelog file as `changelog.gz' instead of
    `changelog.dpkg.gz' (Debian Policy, section 5.8) (Bug#6052,15157)
  * Avoid use of /tmp/*.$$ in preinst and postinst (Bug#19712)
  * Make sure diversions file is always created with mode 0644 (Bug#19494)
  * When removing a file, chmod it to 000 if it's a char or block
    device or remove its s[ug]id bits, if any (Bug#6006)
  * Minor fixes in the programmer's manual (Bug#6206)
  * Always create readable status and available files
    (Bug#9869,11887,14636,15786,19146)
  * Make dpkg-gencontrol honour -DArchtecture=xxxx (Bug#9893)
  * Allow different archs for the same binary in debian/files (Bug#9894)
  * Added workaround in /usr/lib/dpkg/methods/disk/setup
    to avoid bash warning (Bug#10111,10131)
  * Recognize old .deb packages with other locales (Bug#12232)
  * Added `SHELL=bash' to debian/rules: it uses bash-specific structs
  * Move some files from dpkg to dpkg-dev (part of Bug#13295)
  * Minor fix in packaging manual regarding to Standards-Version (Bug#14696)
  * Fixed --altdir and --admindir in update-alternatives (Bug#15332)
  * Strip /usr/lib/libdpkg* (Bug#15671)
  * dpkg: send output of --help, --force-help and -Dhelp to stdout
    (Bug#16051,18574)
  * send correct signals with start-stop-daemon (Bug#17258)
  * Make `dpkg-divert --test --remove' work as expected (Bug#19531)
  * Determine properly the architecture if gcc is egcs (Bug#20353)

 -- Juan Cespedes <cespedes@debian.org>  Sun,  5 Apr 1998 17:37:01 +0200

dpkg (1.4.0.21) unstable; urgency=low

  * Non-maintainer release to include a new update-rc.d
  * Fixed date on files in the archive from 2017 and 2018 by running
    touch foo; find . -newer foo | xargs -r touch; rm foo
  * Changed start-stop-deamon message "No <program> found; none killed." to
    "No <program> found running; none killed."

 -- Miquel van Smoorenburg <miquels@cistron.nl>  Thu,  5 Mar 1998 14:19:46 +0100

dpkg (1.4.0.20) unstable; urgency=low

  * Disabled --force-overwrites.
  * Removed core file from source

 -- Michael Alan Dorman <mdorman@debian.org>  Tue,  9 Jan 2018 03:34:28 -0500

dpkg (1.4.0.19) unstable; urgency=low

  * Changed methods/disk.setup to use output of
    'dpkg --print-installation-architecture' instead of hard-coded 
    '1386' (fixes #10995).
  * Patched dpkg-source to properly quote metacharacters in strings 
    before using them in pattern-matching expressions (fixes #10811).
  * Fixed several documentation typos (fixes #10764).
  * dpkg-source now works around 100-character filename limitation of cpio
    (fixes #10400).
  * dpkg-source now properly handles '\ no newline in source' message from
    patch (fixes #5041).
  
 -- Klee Dienes <klee@debian.org>  Sun, 13 Jul 1997 19:28:22 -0700

dpkg (1.4.0.18) unstable; urgency=low

  * dpkg-source now uses new -z option to GNU patch (still needs to be
    changed to detect and use old version as well) (fixes #9904, #10005, #10007).
  * Added i686 to archtable.
  * shlibs.default now uses xlib6 instead of elf-x11r6lib (fixes #9926).
  * debian-changelog-mode now uses interruptible completing type-in fields
    instead of the previous 'select-a-letter method'.  I consider this
    better and more standard than the previous way, but I'd welcome
    opinions to the contrary.  Consider this a 'probationary' change for
    now (fixes #9873, #9874).

 -- Klee Dienes <klee@debian.org>  Sun, 25 May 1997 09:56:08 -0400

dpkg (1.4.0.17) unstable; urgency=low

  * All of the dpkg binaries (but not dpkg-dev or dselect) now speak
    french, thanks to patches from Christophe Le Bars <clebars@teaser.fr>
  * Fix leading spaces before day in 822-date.
  * Changes from Tom Lees <tom@lpsg.demon.co.uk> to better support
    building on non-Debian systems; minor Makefile fixes.
  * Added 'ppc powerpc powerpc' to archtable.
  * Changed documentation paper size to US/Letter instead of A4 (A4
    may be better, but it's easier to print US/Letter on A4 than it is 
    to print A4 on US/Letter).
  
 -- Klee Dienes <klee@debian.org>  Tue,  13 May 1997 15:24:31 -0400

dpkg (1.4.0.16) experimental; urgency=low

  * Added generated sources to GNU-format source archive so it no longer
    requires perl to build.

 -- Klee Dienes <klee@debian.org>  Sat, 10 May 1997 17:34:29 -0400

dpkg (1.4.0.15) experimental; urgency=low

  * Changed dpkg-genchanges to check for ($arch == $substvar{'Arch'}), not
    ($arch ne 'all') (fixes #9688).
  * Fixed bug in start-stop-daemon.c (was using optarg after argument
    parsing was over) (fixes #9597, #9603, #9364).
  * Provide 50dpkg-dev.el for xemacs as well as emacs.
  * Explicitly provide path for debian-changelog-mode in 50dpkg-dev to use
    .el file as workaround until xemacs can read emacs19 .elc files.
  * Pass top_distdir explicitly to 'make dist' to accomodate bug in
    automake_1.1o-1.
  * Fix debian/build to make html documentation without including
    directories in tar archives (fixes #9348).
  
 -- Klee Dienes <klee@debian.org>  Fri,  9 May 1997 13:17:18 -0400

dpkg (1.4.0.14) experimental; urgency=low

  * Fixed buglet in install-info.pl (fixes #9438).
  * Re-write of update-rc.d.pl, primarily by Miquel van Smoorenburg
    <miquels@cistron.nl> (fixes #9434, #9436).
  * Renamed "dpkg Programmer's Manual" to "dpkg Internals Manual".
  
 -- Klee Dienes <klee@debian.org>  Tue,  6 May 1997 22:01:07 -0400

dpkg (1.4.0.13) experimental; urgency=low

  * Fix to start-stop-daemon so that it still takes numeric arguments (had
    been broken in 1.4.0.12) (fixes #9598).
  * Fix 822-date to sanity-check localtime() output (seconds must be the
    same as GMT).
  * Patch from Guy Maor <maor@ece.utexas.edu> to dpkg-source.pl to support
    pristine (MD5-equivalent) upstream sources.
  * Patch from Michael Alan Dorman <mdorman@calder.med.miami.edu> to
    update-rc.d.pl to fix handling multiple start/stop entries on a single
    line.
  * Several fixes to dpkg-genchanges to support -B option (added in
    1.4.0.12) (fixes #9340).
  * Handle errors from 822-date in debian-changelog-mode.el.
  * Changed cl-debian.pl to correctly handle extra whitespace in changelog
    datestamps.

 -- Klee Dienes <klee@debian.org>  Mon,  5 May 1997 18:12:43 -0400

dpkg (1.4.0.12) experimental; urgency=low

  * Re-wrote 822-date for clarity and to support timezone offsets >= 12h
    (New Zealand in DST is +1300, for example) (fixes #7130).
  * Patch from Juergen Menden <menden@morgana.camelot.de> to support
    archdependent-only builds (fixes #8912, #9245, #5359).
  * Fix archtable entry for powerpc (fixes #8794).
  * Strip /sbin/* and /usr/sbin/* in debian/rules (fixes #8853).
  * Moved start-stop-daemon to /sbin (fixes #8669).
  * Set sharedstatedir and localstatedir for $(MAKE) install in
    debian/rules (fixes #8852).
  * Fixes for update-rc.d(8) from Jim Van Zandt <jrv@vanzandt.mv.com>
    (fixes #8576).
  * No longer do variable substitutions when generating change file (fixes
    #5862).
  * Support symbolic signal names in start-stop-daemon (fixes #7715).
  * Add autoload for debian-changelog-mode to /etc/emacs/site-start.d
    (fixes #4519, #5841).
  * Add recommendation for gcc and make in dpkg-dev (gcc is needed for dpkg
    --print-architecture, used by dpkg-gencontrol; make is needed for any
    debian/rules file) (fixes #8470).
  * Minor changes to packaging manual section on source package
    conversion (fixes #6801).
  * Renamed "programmer's manual" to 'packaging manual'.
  * Start of new "programmer's manual" containing information on dpkg
    internals and build information.  This manual uses the new
    TeXinfo-SGML format, currently included in doc/.
  * dselect/pkgdepcon.cc now checks for debug not NULL, not just depdebug.
  * Changed makefiles to support building outside of source directory.
  * Include GNU-format source distribution with other non-debian packages.

 -- Klee Dienes <klee@debian.org>  Sun,  4 May 1997 11:08:19 -0500

dpkg (1.4.0.11) experimental; urgency=low

  * Patches for alpha and libc6 from Michael Alan Dorman
    <mdorman@calder.med.miami.edu>.
  * Fixed minor problems in dpkg-shlibdeps regular expressions for libc6.
  * Fix regex to detect directory creation in dpkg-source.pl.
  * Minor changes for automake-1.1n.

 -- Klee Dienes <klee@debian.org>  Sun, 23 Mar 1997 18:09:33 -0500

dpkg (1.4.0.10) unstable; urgency=medium

  * Fixed bug in controllib.pl (@fowner was entire passwd entry,
    not just [uid, gid] as it should have been).

 -- Klee Dienes <klee@debian.org>  Thu, 20 Mar 1997 13:06:52 -0500

dpkg (1.4.0.9) unstable; urgency=low

  * Check fputs() return values for (ret >= 0), not (ret != 0) (fixes #7522).
  * dpkg-shlibdeps no longer gives error for Java and statically linked
    binaries (fixes #4988).
  * Change 'details of the old format' to 'details of the new format' in
    deb-old.5 (fixes #7605).
  * dpkg-source -b now warns (was previously silent) if maintainer changes
    create new subdirectories.  dpkg-source -x now warns (previously gave
    error) if maintainer changes create new subdirectories (partially
    fixes #6866, #6671, #5045, #6482).    
  * Added manual page for start-stop-daemon (8). 
  * Added C version of start-stop-daemon by 
    Marek Michalkiewicz <marekm@i17linuxb.ists.pwr.wroc.pl> (fixes #1670).
  * Converted to use GNU automake for the build process by Tom Lees 
    <tom@lpsg.demon.co.uk>.<
  * Preliminary support for dpkg functions as a shared library (now
    provides libdpkg.so, but much work needs to be done in better
    segregating and defining the interface).
  * Preliminary internationalization support by Galen Hazelwood
    <galenh@debian.org>.  Only the library, dpkg-deb, md5sum, and dpkg
    have been converted so far.  No translations have yet been
    constructed.
  * Handle 'libc.so.6 => /lib/libc.so.6 (0x40010000)' format from libc6
    ldd (fixes #7603, #7926, #8688, #9179, #9134, #8516).
  * Removed policy.sgml (it has been moved to the debian-policy package).
  * Include patch from Darren Stalder <torin@daft.com> for
    dpkg-buildpackage to choose PGP key based on Maintainer: field of 
    package being built (or -m<maintainer> option, if present) (fixes 
    #7898).
  * Changed controllib.pl to use $ENV{LOGNAME}, getlogin(), and $<
    (in that order) to determine the intended ownership of 
    debian/{files,substvars},  (fixes #7324, #6823, #5659, #5965, #5929,
    #9239, #5366).
  * Don't sign .dsc file in dpkg-buildpackage if building a binary-only
    release (fixes #7260).
  * Updated developer-keys.pgp to latest revision (fixes #6134).
  
 -- Klee Dienes <klee@debian.org>  Mon, 17 Mar 1997 16:11:24 -0500

dpkg (1.4.0.8) unstable; urgency=medium

  * Corrected update-rc.d for bash 2.0
  * Updated developer-keys.pgp from
    http://www.iki.fi/liw/debian/debian-keyring.tar.gz

 -- Guy Maor <maor@ece.utexas.edu>  Mon, 3 Feb 1997 04:05:01 -0600

dpkg (1.4.0.7) stable unstable; urgency=HIGH

  * Fixed --assert-support-predepends failing between unpack & configure.
  * Added --assert-working-epoch option.

 -- Guy Maor <maor@ece.utexas.edu>  Sat, 25 Jan 1997 23:02:11 -0600

dpkg (1.4.0.6) stable unstable; urgency=high

  * Patched lib/vercmp.c to hopefully fix dselect epoch processing
    (Bug#6204), (Bug#4590).
  * Patched scripts/dpkg-buildpackage, scripts/dpkg-genchanges,
    scripts/dpkg-gencontrol for epoch processing, courtesy of Loic Prylli 
    <lprylli@graville.fdn.fr> (Bug#6138, Bug#5225).
  * Patched dpkg-genchanges to actually honor the -u switch to specify
    directory (Bug#5564).
  * Applied patch to main/archive.c to correct problems setting set[gu]id
    binaries, courtesy of Herbert Xu <herbert@greathan.apana.org.au>
    (Bug#5479). 
  * Applied patch to dpkg-source to correct debian-only package names,
    courtesy of Guy Maor <maor@ece.utexas.edu> (Bug#5355).

 -- Michael Alan Dorman <mdorman@calder.med.miami.edu>  Thu, 2 Jan 1997 11:36:09 -0500

dpkg (1.4.0.5) stable frozen unstable; urgency=medium

  * Distribution for frozen too.

 -- Heiko Schlittermann <heiko@lotte.sax.de>  Thu, 5 Dec 1996 09:13:42 +0100

dpkg (1.4.0.4) stable unstable; urgency=medium

  * Bug2962 fixed: patch from Ian Jackson applied
    (cursor keys won't work after search)
  * Manuals 2.1.2.2

 -- Heiko Schlittermann <heiko@lotte.sax.de>  Fri, 15 Nov 1996 20:21:18 +0100

dpkg (1.4.0.3) unstable; urgency=medium

  * dpkg-source -x: created bad permissions (set x-bit for
    all files pointed to by a symlink)

 -- Heiko Schlittermann <heiko@lotte.sax.de>  Fri, 18 Oct 1996 18:32:06 +0200

dpkg (1.4.0.2) unstable; urgency=medium

  * dpkg-buildpackage.sh: reverted the quoting change -- (you
    should use super, sudo, realy, but not su.  Or write a wrapper
    around su)
  * dpkg-buildpackge.sh: passing -m, -C, -v options to dpkg-genchanges
    more the way Ian likes ;-)
  * dpkg-source.pl: new function deoctify() as replacement for eval()
    (turn \ddd into the corresponding character) [rem: probably better
    solution would be to convert cpios output names into complete \ddd 
    representation as well tars output names] 
  * dpkg-source.pl: fixed 2 typos in failure message on creating 
    $origtargz.tmp-nest.
  * main/main.c: typo `tread' -> `treat'
  * main/enquiry.c: fixed the ignorance for some relations in --compare-versions
  * main/enquiry.c: missing version is now handled as described in `dpkg --help'
    (or at least as I understood `dpkg --help' PLEASE TRY IT)
  * lib/parsehelp.c: fixed parsing of epoch information

 -- Heiko Schlittermann <heiko@lotte.sax.de>  Sun, 6 Oct 1996 23:27:47 +0200

dpkg (1.4.0.1) unstable; urgency=medium

  * dpkg-source: doesn't get screwed up from hardlinks
    in the archive now
  * dpkg-source: doesn't get screwed up from `unprintable' characters
    in file names (e.g. from the kbd package) 
  * controllib.pl: $varlistvile -> $varlistfile (thanx Karl Sackett)
  * dpkg-buildpackge: quoting for $rootcommand (thanx  Michael Meskes)
    and `eval' as default $rootcommand
  * dpkg-*, controllib.pl: created debian/files and debian/substvars
    are chown'ed to `getlogin()' and its group
  * doc/: mv changed to mv -f
  * dpkg-buildpackage: added an option -a for overriding the
    architecture in the changes _file_name_
  * dpkg-buildpackage: pass -m* -v* .. options to dpgk-genchangelog
  * dpkg-name moved to dpkg-dev

 -- Heiko Schlittermann <heiko@lotte.sax.de>  Sat, 21 Sep 1996 22:06:01 +0200

dpkg (1.4.0) unstable; urgency=low (HIGH for new source format)

  * Corrected buffer overrun when dpkg-deb generates filename.  (Bug#4467.)
  * dpkg-shlibdeps works with DEBIAN/shlibs (thanks Heiko Schlittermann).
  * Added libm.so.5 to shlibs.default for i386/m68k.

  * Split binary package into two: dpkg and dpkg-dev.
  * dpkg-source(1) documents mode and ownership setting during extraction.

  * dpkg-scanpackages moved to /usr/bin.
  * Include /usr/bin/dpkg-deb, not dpkg-deb.dist; don't rename in scripts.
  * Copyright file changed slightly.
  * debian-changelog-mode uses magic key substitution strings.  (Bug#4419.)
  * Changed email address in control file to <ian@chiark.greenend.org.uk>.
  * Manuals and own Standards-Version: updated to 2.1.1.0.

 -- Ian Jackson <ian@chiark.greenend.org.uk>  Thu, 12 Sep 1996 01:13:33 +0100

dpkg (1.3.14) unstable; urgency=low

  * dpkg-buildpackage new -tc (clean source tree) option.

  * Formatted documentation removed by `make clean' and so not in source.
  * Manuals and own Standards-Version: updated to 2.1.0.0.
  * Distribute {policy,programmer}.{html.tar,ps}.gz with each upload.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Sun, 1 Sep 1996 20:43:40 +0100

dpkg (1.3.13) unstable; urgency=low (HIGH for building new src X programs)

  * X shared libraries added to shlibs.default (=> `elf-x11r6lib').
  * dpkg-source tar invocation fixed so that TAPE env var doesn't break it.
  * dpkg-source copes better with missing final newline messages from diff.

  * dpkg-buildpackage usage message fixed: -si is the default.  (Bug#4350.)
  * dpkg-source error message about src dir mismatch typo fixed.  (Bug#4349.)

  * dpkg-source(1) has suggestions for dpkg-buildpackage -r option.
  * dpkg-source change date fixed.  (Bug#4351.)
  * More developers' keys.
  * Manual updates, own Standards-Version updated.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Sat, 31 Aug 1996 20:08:18 +0100

dpkg (1.3.12) unstable; urgency=medium

  * dpkg prints old version number when upgrading.  (Bug#4340.)
  * dpkg-deb tries to detect and flag corruption by ASCII download.

  * dpkg-genchanges and dpkg-buildpackage say what source is included.

  * dpkg-buildpackage passes +clearsig=on to PGP (or pgpcommand).  (Bug#4342.)

  * dpkg-source prints better error for cpio not honouring -0t.
  * control file Suggests cpio >= 2.4.2, rather than just cpio.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Fri, 30 Aug 1996 15:31:51 +0100

dpkg (1.3.11) unstable; urgency=low

  * EBUSY when dpkg removes a directory is only a warning.

  * dpkg-genchanges generates sensible warning (not confusing error
    about mismatch) for missing Section/Priority in binary packages.

  * Added dpkg --print-gnu-build-architecture option.
  * shlibs.default for m68k provided, as a copy of i386 version.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Thu, 29 Aug 1996 14:05:02 +0100

dpkg (1.3.10) unstable; urgency=medium

  * dpkg-source(1) manpage alias symlinks are not dangling.
  * dselect selects things by default if they are installed.
  * Added `pentium' as alias for `i386' architecture.
  * Added `Suggests: cpio, patch' and explanatory text to Description.
    (Bugs #4262, #4263.)

  * More developers' PGP keys.
  * Manual updates, new source format released.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Mon, 26 Aug 1996 14:30:44 +0100

dpkg (1.3.9) unstable; urgency=low (high for new source format)

  * dpkg --get-selections and --set-selections added.
  * New dpkg --force-not-root flag.

  * Don't replace directory with another package's file.  (Bug#4202.)

  * All manpages now installed compressed.
  * Copyright file moved to /usr/doc/dpkg/copyright.
  * Standards-Version updated (0.2.1.1).

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Sat, 24 Aug 1996 19:09:30 +0100

dpkg (1.3.8) unstable; urgency=low (high for new source format)

  * dpkg-buildpackage -sa, -si options work correctly.

  * update-rc.d(8) updated to reflect design and reality.
  * Programmers' and policy manual updates.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Fri, 23 Aug 1996 12:48:26 +0100

dpkg (1.3.7) unstable; urgency=low (medium for source pkg docs)

  * dselect +/-/_/= on lines for all broken, new, local or whatever
    packages do not affect _all_ packages.  (Bug#4129.)

  * Support for diff-only uploads in source packaging tools.
  * dpkg-genchanges -d<descripfile> option renamed to -C.
  * dpkg-buildpackage understands -m, -v, -C (for dpkg-genchanges).
  * Support for debian/shlibs.local added to dpkg-shlibdeps.
  * Shared library files' search order defined in dpkg-source(1), and
    relevant files added to the FILES section.

  * Programmers' manual describes source packaging tools.
  * Policy manual mentions shared library control area file.
  * dpkg-source manpage includes dpkg-shlibdeps in title line.
  * Manuals have changelog and automatic version numbering.
  * changelogs (for dpkg and for manuals) installed.
  * binary target split into binary-arch and binary-indep in manual.
  * Manpages should be compressed.
  * Copyright file is moved to /usr/doc/<package>/copyright.
  * Changelogs must be installed in /usr/doc/<package>.
  
  * dpkg-deb(8) moved to dpkg-deb(1).

  * binary target split into binary-arch and binary-indep in source.
  * changelog entry for 1.2.14 copied from that (forked) release.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Thu, 22 Aug 1996 15:36:12 +0100

dpkg (1.3.6) experimental; urgency=low (HIGH for new source format)

  * dpkg-source now has broken argument unparsing for tar.  (Bug#4195.)

  * dpkg-gencontrol writes to debian/tmp/DEBIAN/control by default.
  * dpkg-shlibdeps script added.

  * Back to old sh update-rc.d, and removed manpage, because new Perl
    version and the manpage have different syntax and semantics.
  * update-rc.d prints usage message for missing terminal `.'.  (Bug#4122.)

  * Use rm -rf instead of just rm -r in dpkg-deb --info &c.  (Bug#4200.)

  * Added support for Installed-Size to dpkg-gencontrol, and documented.
  * Source packaging substitution variables and name syntax rationalised.
  * dpkg-source scripts' usage messages improved slightly.
  * dpkg-source works with non-empty second (orig dir) argument.

  * Added rationale for copyright policy to manual.
  * More developers' PGP keys.
  * Control database handling cleanups (usu. Source field blanked).

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Tue, 20 Aug 1996 15:39:58 +0100

dpkg (1.3.5) experimental; urgency=low (high for debian-changelog-mode)

  * 822-date script included.  (Bug#4136.)
  * debian-changelog-add-version works on empty file.
  * debian-changelog-mode mode-help works properly.

  * dpkg-source tells patch not to make numbered backups.  (Bug#4135.)

  * More developers' PGP keys.
  * Paragraph on uucp -a and -g options removed from policy manual.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Wed, 14 Aug 1996 14:46:47 +0100

dpkg (1.3.4) experimental; urgency=low

  * Removed debugging output from dpkg-source -x.  Oops.
  * Removed section on source package permissions from policy manual -
    dpkg-source now sorts these out.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Sun, 11 Aug 1996 13:25:44 +0100

dpkg (1.3.3) experimental; urgency=low

  * Programmers' & policy manuals in source tree; HTML in /usr/doc/dpkg.
  * Old guidelines.info and text files in /usr/doc/dpkg removed.

  * dpkg-source sets permissions on extracted debianised source tree
    and does not copy ownerships out of archive even if running as root.

  * Emacs mode `dpkg changelog' renamed to `Debian changelog'.
  * Default changelog format renamed from `dpkg' to `debian'.

  * debian-changelog-mode sets fill-prefix correctly.
  * debian-changelog-mode urgencies except HIGH lowercase by default.
  * debian-changelog-mode displays keymap in doc string and so mode help.

  * More maintainers' PGP keys.

  * Remove built changelog parsers with `clean' target in source.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Sat, 10 Aug 1996 23:35:51 +0100

dpkg (1.3.2) experimental; urgency=LOW (MEDIUM for dpkg-source)

  * Faster update-rc.d written in Perl by Miquel van Smoorenburg.
  * install-info --test doesn't lock dir.  (Bug#3992, thanks Darren).

  * dpkg-source doesn't break in the presence of any symlinks.

  * More developers' keys added to doc/developer-keys.pgp.
  * Install developers' keys in /usr/doc/dpkg/developer-keys.pgp.
  * dpkg-source documents undefined substvar behaviour.
  * minor debian/rules cleanups.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Sat, 10 Aug 1996 02:13:47 +0100

dpkg (1.3.1) experimental; urgency=LOW

  * manpage for dpkg-source et al now available.
  * dpkg-changelog-mode.el installed in site-lisp, but still no autoload.

  * dpkg-source prints correct string for not-understood tar -vvt output.
  * dpkg-source parsing of tar -vvt output made more robust.

  * dpkg-buildpackage prints usage message on usage error.
  * dpkg-gencontrol can print usage message.
  * -T<varlistfile> option added to dpkg-source.
  * Description of -f<fileslistfile> corrected in dpkg-distaddfile usage.
  * -m<maintainer> synopsis changed in dpkg-genchanges usage.
  * debian/substvars may now contain blank lines.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Thu, 8 Aug 1996 02:36:04 +0100

dpkg (1.3.0) experimental; urgency=LOW

  * dpkg can install named pipes.
  * dpkg-deb supports directory for destination, generates filename.
  * dpkg-{source,gencontrol,genchanges,parsechangelog,buildpackage},
    dpkg-distaddfile scripts to support new source package format.
  * a.out build no longer supported.
  * Changed to new source package format.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Tue, 6 Aug 1996 02:31:52 +0100


dpkg (1.2.14) stable unstable; urgency=MEDIUM

  * dselect +/-/_/= on lines for all broken, new, local or whatever
    packages do not affect _all_ packages.  (Bug#4129.)

  * NOTE - THE HISTORY FORKS HERE.  1.2.14's change appears in 1.3.7.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Thu, 22 Aug 1996 00:39:52 +0100


dpkg (1.2.13) unstable; urgency=LOW

  * dpkg --search produces correct output for diversions.
  * dpkg-name remove unnecessary arch missing warning.  (Bug#3482.)

  * dpkg-deb --build warns about uppercase chars in package name.

  * dpkg-scanpackages error messages updated and manpage provided
    (thanks to Michael Shields).
  * dpkg-scanpackages warns about spurious entries in override file.
  * dpkg-scanpackages `noverride' renamed to `override' everywhere.
  * dpkg-scanpackages field ordering to put Architecture higher.
  * dpkg-scanpackages field names capitalised appropriately.
  * dpkg-scanpackages invokes find with -follow.  (Bug#3956.)

  * guidelines say #!/usr/bin/perl everywhere, not #!/bin/perl.
  * Many developers' PGP keys added.

  * configure script uses ${CC} instead of $(CC) (again :-/).
  * developers' keys included in dpkg source tree and /usr/doc.
  * configure remade using autoconf 2.10-3 (was 2.4-1).

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Thu, 1 Aug 1996 02:46:34 +0100

dpkg (1.2.12); priority=LOW

  * dpkg --search and --list understand and comment on diversions.
  * dpkg-divert displays diversions more intelligibly.

  * Guidelines are somewhat clearer about descriptions.
  * deb(5) describes new format; old moved to deb-old(5).  (Bug#3435.)
  * deb-control(5) carries a warning about being out of date.

  * Added 1996 to dselect version/copyright.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Thu, 4 Jul 1996 15:04:49 +0100

dpkg (1.2.11); priority=MEDIUM

  * dselect had dependency bug if installed package newer than avail.
  * Added `replaces' to dselect's list of package relationship strings.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Mon, 1 Jul 1996 02:51:11 +0100

dpkg (1.2.10); priority=MEDIUM

  * Fixed bug in old-style version/revision number parsing.  (Bug#3440.)

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Sat, 29 Jun 1996 03:32:45 +0100

dpkg (1.2.9); priority=MEDIUM

  * Fixed status database updates reading bug.
  * `Setting up' message includes version number.
  * `existence check' message changed to say `cannot access archive'.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Thu, 27 Jun 1996 13:39:36 +0100

dpkg (1.2.8); priority=LOW

  * dpkg --record-avail puts data in Size field.
  * strip / for rmdir(2) in cleanup to work around kernel bug.  (Bug#3275.)
  * dpkg-split --msdos no longer allows `-' and other chars in filenames.

  * manual dpkg-split(8) written.
  * dpkg-split minor typo in --auto usage error message fixed.
  * dpkg-deb(8) very minor cosmetic fix to --build option.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Tue, 25 Jun 1996 03:00:14 +0100

dpkg (1.2.7); priority=LOW

  * dpkg-scanpackages syntax errors fixed.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Fri, 21 Jun 1996 04:10:38 +0100

dpkg (1.2.6); priority=MEDIUM

  * NFS, CDROM and partition dselect methods include mountpoint
    in paths given to dpkg in [I]install, so they should now work.

  * Removed some leftover files from source tree.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Wed, 12 Jun 1996 14:35:19 +0100

dpkg (1.2.5); priority=MEDIUM

  * Allow, but do not create, packages in half-installed state
    with no version number.  (Aargh.)

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Mon, 10 Jun 1996 04:55:43 +0100

dpkg (1.2.4); priority=MEDIUM

  * New dpkg-name from Erick (<pkg>_<version>_<arch>.deb convention).
  * Disappeared packages can't own conffiles any more !  (Bug#3214.)
  * install-info creates Miscellaneous sections with a newline
    following the heading.  (Bug#3218.)
  * cleanup-info script installed in /usr/sbin; called as appropriate
    by postinst.  Thanks to Kim-Minh Kaplan.  (Bug#3125.)
  * Allow superseded Essential packages to be purged after they've
    been removed (clear the Essential flag on removal, and ignore it
    on packages that are in stat_configfiles).

  * dselect disk methods understand `y' as well as `yes' for using
    development tree.
  * dselect doesn't make packages appear as `new' again if update
    of available packages fails.
  * dselect places method selection cursor over option last selected.

  * dpkg-scanpackages doesn't die when repeated packages are found.
  * dpkg-scanpackages allows many old maintainers (`//'-separated).

  * `Version' field is now mandatory (some operations already
    wouldn't work right anyway if it was't there).

  * update-rc.d(8) now says you must remove the script.  (Bug#3215.)
  * dpkg --force-help says that --force-overwrite is on by default.
  * dpkg-deb manpage rewritten.
  * debian.README (= /usr/doc/copyright/dpkg) edited slightly.

  * Some database parsing grunge removed (pdb_preferversion, &c).
  * Source tree doc/sgml contains some embryonic manuals.
  * Leftover files in lib directory in source tree deleted.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Mon, 10 Jun 1996 03:52:01 +0100

dpkg (1.2.3); priority=HIGH

  * install-info doesn't replicate section headings (Bug#3125, #2973).
  * New dpkg-name manpage broken off from script (oops!).
  * dselect help screens made consistent with new strings, flags, &c.
  * dselect error flag column labelled E (Error), not H (Hold).
  * `Escape' no longer bound to `exit list without saving' in dselect.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Tue, 28 May 1996 02:14:57 +0100

dpkg (1.2.2); priority=MEDIUM

  * Fixed dselect coredump found by Erick Branderhorst (thanks).
  * Sort obsolete removed packages separately, not under Available.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Thu, 23 May 1996 21:31:05 +0100

dpkg (1.2.1); priority=MEDIUM

  * `=' key in dselect really does `hold' rather than `unhold'.
  * dselect dependency processing now interacts better with `hold'.
  * dselect `I' key (not `i') modifies display of the info window.
  * dselect shows unavailable packages as being unavailable.
  * dselect main menu headings and many other strings changed to try to
    discourage people from deselecting every package and using [R]emove.
    Notably, `select' changed to `mark' throughout.

  * dselect disk methods now print a few fewer double slashes.
  * dselect disk access methods will offer to use dpkg --record-avail
    to scan the available packages, if no Packages file is found.

  * New dpkg --compare-versions option, for the benefit of scripts &c.
  * New dpkg --clear-avail option forgets all available packages info.
  * New dpkg --print-avail option, prints `available' data (from Packages, &c).
  * dpkg usage message is more informative, but no longer fits on screen.
  * dpkg --avail option renamed --record-avail.

  * Latest dpkg-name from Erick Branderhorst.
  * dpkg-scanpackages has more sensible problem reporting.
  * postinst configure now gets null argument (not <unknown> or <none>)
    when there is no previously configured version.

  * Guidelines say that postinst configure is given previous version.
  * Guidelines don't refer to maintainer-script-args.txt in main text.
  * Guidelines (Texinfo source) uploaded separately.

  * Own version of strcpy (used for debugging) removed.
  * Interface to access methods document in source (doc/dselect-methods.txt).
  * debian.buildscript moves changes file into parent directory.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Wed, 22 May 1996 01:26:31 +0100

dpkg (1.2.0); priority=MEDIUM

  * dselect can sort packages by available and installed states, and
    display their version numbers.  (Use O, o and V.)
  * Hold is properly integrated as a real `wanted state', rather than
    a separate flag.
  * Epochs in version numbers implemented, using the syntax
    <epoch>:<version>-<revision>.  (Epoch not usually displayed.)
  * dselect disk method is architecture-independent (uses dpkg's
    installation architecture, and looks in the right part of the tree).

  * dselect disk method doesn't try to satisfy the predependencies of
    packages which are on hold.
  * Fixed conflict-related assertion failure.  (Bug#2784.)
  * conffiles do not cause file conflicts if the conflicting package
    is in the `configuration only' state.  (Bug#2720.)
  * Fixed messages where available version number was reported as installed
    version in conflict and dependency messages.  (Bug#2654, Bug#2974.)

  * New format .deb files are default even for a.out compiles (but
    a.out version of dpkg is in old format).
  * Characters @:= (at colon equals) in package names now strictly
    forbidden everywhere (_ is still allowed in existing packages).
  * New dpkg --print-installation-architecture option prints installation
    architecture (compiled in), rather than build architecture (determined
    from gcc -print-libgcc-file-name).

  * Version messages show whether compiled a.out or ELF (i386 only).
  * Fixed missing space in version syntax error messages.
  * Manpage dpkg.8 installed with warning about inaccuracy.

  * Guidelines don't say to stop and restart daemons in runlevels 2345;
    instead they say to start in 2345 and stop in 016.
  * Guidelines and version messages say just Debian Linux.
  * Guidelines typo fix `"stop2' => `"stop"'.  (Bug#2867.)

  * doc/Makefile.in clean properly deletes various guidelines.info* files.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Thu, 16 May 1996 00:01:21 +0100

dpkg (1.1.6); priority=MEDIUM

  * Check virtual dependencies when removing (ouch! - thanks SDE.)
  * Fixed bug in internal database validity management that could
    make dselect and dpkg dump core.  (Bug#2613.)
  * Fixed two coredumping bugs when using local diversions.  (Bug#2804.)
  * Fixed disappearance of overwritten packages.  (Bug#2696.)
  * install-info won't modify dir file before start of menu.
  * install-info will create Miscellaneous heading if no sections yet.

  * Only alphanums and +-. allowed in package names - enforced by
    dpkg-deb --build and documented in Guidelines.
  * dselect doesn't display packages unless they are installed, selected
    or available.
  * dselect doesn't show spurious section and priority headings.
  * dselect has a few extra keybindings (from Lee Olds).
  * --force message changed to `--force enabled' so that default is OK.

  * dpkg-name now includes architecture component in .deb filename,
    and translates - in package name to _.
  * .deb file has architecture component in filename.

  * Guidelines changed to say Pre-Depends is for experts only.
  * Guidelines say to provide a unidiff (-u) rather than an old context diff.
  * Guidelines say 755 root.root for shared libraries.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Wed, 1 May 1996 00:47:22 +0100

dpkg (1.1.5); priority=MEDIUM (HIGH for diversions users)

  * Fixed coredump when using diversions.  (Bug#2603.)
  * Fixed typo in dpkg-divert which could lose diversions.  (Bug#2662.)

  * --force-overwrite is the default.
  * diversions.text provides better examples.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Wed, 10 Apr 1996 13:59:30 +0100

dpkg (1.1.4); priority=MEDIUM

  * Allow overwriting of conflicting packages being removed.  (Bug#2614.)

  * a.out control file says Pre-Depends: libc4 | libc.  (Bug#2640.)
  * ELF control file and libc dependencies changed to use finalised scheme.
  * ELF control file and libc dependencies for i386 only.  (Bug#2617.)

  * Guidelines say use only released libraries and compilers.
  * Install wishlist as /usr/doc/dpkg/WISHLIST.
  * Remove spurious entries for Guidelines in info dir file.

  * dpkg-deb --build checks permissions on control (DEBIAN) directory.

  * Spaces in control file fields not copied by dpkg-split.  (Bug#2633.)
  * Spaces in split file part control data ignore.  (Bug#2633.)

  * Portability fixes, including patch from Richard Kettlewell.
  * Fixed minor configure.in bug causing mangled GCC -W options.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Thu, 4 Apr 1996 01:58:40 +0100

dpkg (1.1.3); priority=LOW

  * dselect disk methods support Pre-Depends installation ordering.
  * When dpkg fails and --auto-deconfigure would help it says so.
  * dpkg --search output lists several packages with same file on one line.
  * Improved dpkg usage message somewhat.

  * dpkg-deb --build checks permissions and types of maintainer scripts.
  * dpkg-deb --build treats misspecified conffiles as error, not warning.
  * dpkg --print-architecture prints compiler's architecture while
    dpkg --version (&c) print system's arch (this to help cross-compiling).
  * More minor guidelines changes, including dir entry fixup.

  * configure script caches more values.
  * Changed maintainer email address to ian@chiark.chu.cam.ac.uk.

 -- Ian Jackson <ian@chiark.chu.cam.ac.uk>  Sat, 16 Mar 1996 19:18:08 +0000

dpkg (1.1.2); priority=LOW

  * Packaging guidelines installed properly (and as guidelines
    rather than debian-guidelines).
  * ELF version has more checks to stop you wrecking your dpkg installation.
  * dselect disk methods now look for a `local' tree as well, for
    people who want locally-available software of various kinds.
  * dpkg-divert has debugging message removed.
  * Minor guidelines changes.

  * Various makefile cleanups, mainly to do with ELF vs. a.out support.
  * debian.rules cleans out ~ files itself, as well as calling make clean.
  * debian.rules names .nondebbin.tar.gz file ELF too, if appropriate.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Thu, 14 Mar 1996 03:38:29 +0000

dpkg (1.1.1elf); priority=LOW

  * Added /usr/lib/dpkg/elf-executables-ok and elf-in-kernel.
  * Replaces field now allows automatic removal of conflicting packages.
  * Replaces field now required to overwrite other packages' files.
  * Architecture field, and dpkg --print-architecture, supported.
  * build new format archives by default when compiled with ELF compiler.

  * symlinks are now installed atomically (good for shared libraries).
  * create /var/lib/dpkg/diversions in postinst if necessary (Bug#2465.)
  * Pre-Depends now correctly fails if package never configured.
  * dselect disk methods mount with -o nosuid,nodev.
  * update-rc.d defaults doesn't add both K and S in any one runlevel;
    dpkg postinst fixes up this situation if it sees it.

  * Assorted fixups to the Guidelines, which are now in one piece.
  * dpkg --list prints version string in one piece.
  * dpkg-scanpackages doesn't produce notice on output with list of
    packages with Section and/or Priority control file fields.

  * control file and debian.rules work both for ELF and non-ELF compiles.
  * most files compiled with -O2 (-O3 only for some critical files) -
    this fixes ELF build.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Mon, 11 Mar 1996 04:25:28 +0000

dpkg (1.1.0); priority=LOW

  * dpkg supports Pre-Depends.
  * postinst script gets most-recently-configured version as $2.

  * lib/tarfn.c #includes <errno.h> (portability fix).

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Sun, 11 Feb 1996 21:07:03 +0000

dpkg (1.0.17); priority=LOW

  * dpkg --recursive follows symlinks (useful for devel tree).

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Sat, 10 Feb 1996 15:58:46 +0000

dpkg (1.0.16); priority=LOW

  * dpkg-deb much faster reading new format archives.  (Bug#2256.)
  * Developers' documentation in /usr/doc/dpkg/, /usr/info/.

  * Fixed typo in control file Description.

  * configure script tries to improve matters wrt sysinfo.
  * any debian-tmp.deb is deleted by `./debian.rules clean'.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Sun, 4 Feb 1996 15:51:59 +0000

dpkg (1.0.15); priority=LOW

  * dselect disk methods should never unmount things they didn't mount.
  * debian.README aka /usr/doc/copyright updated.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Tue, 30 Jan 1996 15:05:39 +0000

dpkg (1.0.14); priority=MEDIUM

  * fixed file descriptor leak in dpkg introduced in 1.0.11.
  * included dpkg-name in this package (conflicts with dpkg-name).

  * redraw in dselect main menu changed to use clearok (like in lists).
  * sa_restorer in struct sigaction no longer used (portability fix).
  * removed Guidelines from source package.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Tue, 30 Jan 1996 02:52:29 +0000

dpkg (1.0.13); priority=MEDIUM

  * dselect partition and mounted methods work again.
  * dpkg-deb --no-act in usage message.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Fri, 26 Jan 1996 18:37:03 +0000

dpkg (1.0.12); priority=MEDIUM (HIGH for users of 1.0.11)

  * Fixed frequent dpkg coredump introduced in 1.0.11.  (Bug#2219.)
  * dpkg-deb ensures version numbers start with alphanumerics.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Wed, 24 Jan 1996 00:42:31 +0000

dpkg (1.0.11); priority=MEDIUM

  * corrected potentially serious problem with dpkg low-memory in-core
    files database.
  * dpkg-split --msdos puts output files in right directory.  (Bug#2165.)

  * diversions implemented - see `dpkg-divert --help'.

  * dselect shows and uses (for dependencies) currently installed
    version of a package if that is more recent.
  * dpkg --force-... options are in separate help screen.
  * better error messages for corrupted .deb archives.  (Bug#2178.)
  * dselect NFS method will unmount correct copy of NFS area if mounted
    twice.

  * removes some ELF compilation warnings.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Fri, 19 Jan 1996 02:41:46 +0000

dpkg (1.0.10); priority=MEDIUM

  * dpkg-deb option parsing unmuddled (-I option was removed
    in 1.0.9 and broke dpkg-deb).  (Bug#2124.)

  * dpkg-split will work when ELF `ar' is installed, and is faster.

  * nfs dselect method now available.
  * disk methods don't prompt spuriously for Packages files.
  * cdrom+harddisk methods can find Packages files.

  * dpkg-scanpackages (creates Packages files) now in /usr/sbin.

  * various changes to help compilation of dpkg-deb, dpkg-split
    and md5sum on non-Debian systems.
  * <sys/fcntl.h> replaced by <fcntl.h> throughout.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Sun, 14 Jan 1996 02:55:19 +0000

dpkg (1.0.9); priority=MEDIUM

  * dselect uninitialised variable coredump fixed (thanks Carl).

  * version numbers printed by --version fixed.  (Bug#2115.)
  * disk method problem with missing Packages files fixed.  (Bug#2114.)
  * dependency version relationships now <= >= << >> =.  (Bug#2060.)

  * install-info is in /usr/sbin, not /usr/bin.  (Bug#1924.)
  * dpkg regards Revision field as obsolete.

  * <asm/unistd.h> changed to <linux/unistd.h> (for m68k port).
  * scripts/Makefile.in `clean' target deletes scripts.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Thu, 11 Jan 1996 20:51:20 +0000

dpkg (1.0.8); priority=LOW

  * update-alternatives slightly more helpful message.  (Bug#1975.)
  * cosmetic improvements to disk installation method.  (Bug#1970,1956.)
  * mounted filesystem and unmounted partition separate methods.  (Bug#1957.)

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Tue, 12 Dec 1995 04:07:47 +0000

dpkg (1.0.7); priority=MEDIUM (HIGH to upgrade syslogd)

  * dselect harddisk/CDROM method script handles multiple package
    areas.
  * Everything has a manpage, though many are very unhelpful indeed.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Thu, 30 Nov 1995 03:59:14 +0000

dpkg (1.0.6); priority=MEDIUM (HIGH to upgrade syslogd)

  * conffiles can now be taken over properly from one package by
    another which replaces it.  (Bug#1482.)
  * dpkg will not deconfigure essential packages when --auto-deconfigure
    is set (this bug was fairly unlikely ever to be exercised).

  * dpkg checks for the presence of certain important programs on the PATH.
  * dselect is now more informative when a dependency is missing, saying
    "<package> does not appear to be available".  (Bug#1642, 1705).

  * `make distclean' fixed; config.* &c removed from source archive.
  * lib/lock.c now uses fcntl rather than flock, for better portability.

  * `Package_Revision: 0' removed from control file.
  * Some inaccuracies and bad formatting in various messages corrected.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Tue, 21 Nov 1995 20:15:18 +0000

dpkg (1.0.5); priority=LOW

  * dpkg-split allows some space for the header.  (Bug#1649.)
  * dpkg-split now has --msdos option for 8.3 filenames.
  * dpkg-split --join &c will not complain about trailing garbage.

  * dselect & dpkg will no longer ignore SIGHUP will running subprocesses.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Fri, 13 Oct 1995 13:59:51 +0100

dpkg (1.0.4); priority=MEDIUM (HIGH for dselect users with 1.0.3)

  * fixed bug which prevented dselect from displaying the bottom line of
    any listing screen.  This was introduced in 1.0.3, sorry !

  * a conffile will never cause a prompt if the package maintainer
    distributes a file identical to the user's, even if the file has
    been edited by both the user and the maintainer or is a
    newly-registered conffile.  (Bug#1639.)

  * dselect disk/cdrom method script says where to get Packages file.
  * dselect help has better descriptions of the functions of Return and Q.

  * postinst now warns about some problems with /usr/lib/dpkg/methods/hd.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Thu, 12 Oct 1995 01:45:38 +0100

dpkg (1.0.3); priority=MEDIUM

  * dselect: fixed segfault when doing some multiple (de)selections.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Tue, 10 Oct 1995 03:21:12 +0100

dpkg (1.0.2); priority=MEDIUM

  * problem with screen refresh after `o' (change order) corrected.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Mon, 9 Oct 1995 13:11:04 +0100

dpkg (1.0.1); priority=LOW

  * much better dpkg performance on low-memory systems.
  * start-stop-daemon --name should now work. (oops!)
  * fixed typo which could turn into memory overwriting bug sometime.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Sun, 8 Oct 1995 20:12:29 +0100

dpkg (1.0.0); priority=LOW

  * Version 1.0.0: dpkg is no longer beta.

  * tar extractor no longer looks up an empty string using getgrnam
    (this causes the libc to coredump when using NIS).

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Sun, 1 Oct 1995 13:07:36 +0100

dpkg (0.93.80); priority=LOW

  * dselect help screen intro changed to remove `much' before `help'.

  * update-alternatives.pl contains hardcoded ENOENT value, instead
    of requiring POSIX.pm to be present.

  * Makefiles changed to strip when installing instead of when building.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Sat, 30 Sep 1995 01:44:12 +0100

dpkg (0.93.79) BETA; priority=LOW

  * DPKG_NO_TSTP environment variable which stops dpkg sending the
    process group a SIGTSTP (Bug#1496).
  * End key should work in dselect lists (Bug#1501).
  * various message typos (missing \n's) fixed (Bug#1504).

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Fri, 29 Sep 1995 03:27:01 +0100

dpkg (0.93.78) BETA; priority=LOW

  * dselect keystrokes help file typo fix.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Thu, 28 Sep 1995 20:31:02 +0100

dpkg (0.93.77) BETA; priority=MEDIUM

  * dpkg --remove --pending will purge things when appropriate.

  * fixed failure to null-terminate dpkg conflict problem messages.
  * fixed bug in formatting of dependency version problem messages.

  * Conffiles resolution prompt for new conffile: typo fixed.
  * Changed dpkg usage error to suggest `-Dhelp' instead of `--Dhelp'.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Wed, 20 Sep 1995 23:44:35 +0100

dpkg (0.93.76) BETA; priority=MEDIUM

  * dpkg --auto-deconfigure option (used automatically by dselect) allows
    `important' packages which many others depend on to be split.
  * dpkg should no longer fail an assertion during complicated
    multiple configurations involving packages which are on hold.

  * update-alternatives supports negative priorities.
  * /etc/alternatives is included in the .deb archive.

  * Package priorities changed: Required (Req), Important (Imp), Standard (Std),
    Optional (Opt) and Extra (Xtr).  For backward compatibility Base is an
    alias for Required, and Recommended is kept as a level just below Standard.

  * dselect shows introductory help screen when entering package lists (both
    main and recursive).
  * dselect help messages made more friendly.
  * dselect package list `quit, confirm, and check dependencies' key is
    now Return rather than lowercase `q'; likewise method list `select this
    one and configure it' key.
  * dselect selects packages with priority `standard' or better by default.
  * dselect `v=verbose' becomes `v=terse' when in verbose mode.

  * hard disk method unmounts /var/lib/dpkg/methods/mnt on failure.
  * disk methods' install message uses `stty' to find out what the
    interrupt character is, and uses that in the prompt (rather than ^C).
  * dpkg now tolerates ^Z characters in Packages files.
  * harddisk method doesn't display extra slash when updating packages file.
  * harddisk method burbles less if it doesn't have a good default.

  * dpkg-deb now supports new flexible format, but old format still default.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Wed, 20 Sep 1995 02:49:41 +0100

dpkg (0.93.75) BETA; priority=MEDIUM

  * dselect no longer segfaults when you try to modify the last item.

  * dselect Makefile compiles with -g, and links without -s, but installs
    with -s, so that built source directory has debugabble binary.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Tue, 12 Sep 1995 02:59:29 +0100

dpkg (0.93.74) BETA; priority=LOW

  * dpkg-split implemented and installed in /usr/bin/dpkg-split.
    (NB this is not compatible with Carl Streeter's old dpkg-split script.)
  * dpkg uses dpkg-split.
  * floppy disk method available - NB this is a first attempt only.

  * hard disk method uses --merge-avail rather than --update-avail.
  * installation by default of `standard' packages removed again.
    (I don't think this is the right place to do this.)
  * update-alternatives --remove correctly deletes all slave links;
    minor cosmetic improvements.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Mon, 11 Sep 1995 02:06:05 +0100

dpkg (0.93.73) BETA; priority=LOW

  * dselect multi-package selection now done by `divider' lines
    actually in the package list, rather than horizontal highlight
    movement.
  * dselect help available, and keybindings rationalised.

  * postinst removes /usr/lib/dpkg/methods/hd if upgrading from
    0.93.42.3 or earlier.
  * `hold' flag changed to be settable by the user only, and
    made orthogonal to the `reinstallation required' flag.
  * dpkg will install by default any packages with priority of
    `standard' or better unless they're explictly deselected.

  * dselect dependency/conflict resolution will suggest marking absent
    packages for `purge' rather than `deinstall'.
  * disk method script produces message about invoking dpkg.
  * dpkg produces warning, not error, when it gets EPERM trying to
    remove a directory belonging to a package being removed.
  * dpkg, dpkg-deb usage error reporting improved.
  * dselect detects too-dumb terminals and stops.
  * dpkg-deb(8) updated a little (thanks to Bill Mitchell).

  * dselect debugmake script uses -O0.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Sun, 10 Sep 1995 12:23:05 +0100

dpkg (0.93.72) BETA; priority=MEDIUM

  * /usr/sbin/update-alternatives added.

  * New names for certain control file fields (old names work
    as aliases): Optional -> Suggests, Recommended -> Recommends,
    Class -> Priority.
     
 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Sun, 3 Sep 1995 16:37:41 +0100

dpkg (0.93.71) BETA; priority=LOW

  * dpkg doesn't silently overwrite `new' conffiles (Bug#1283).
  * case now not significant in Essential, Status and Class (Bug#1280).
  * dselect checks method scripts for execute, not for write.

  * spelling fixes in lib/dbmodify.c and dselect/helpmsgs.src.

  * dselect `clean' target deletes helpmsgs.cc and helpmsgs.cc.new.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Thu, 31 Aug 1995 13:56:08 +0100

dpkg (0.93.70) BETA; priority=MEDIUM

  * dselect unmounted harddisk method has many silly bugs fixed.

  * dpkg --root option restored (was removed by mistake in 0.93.68).
  * minor cosmetic change to dselect subprocess failure message.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Wed, 9 Aug 1995 22:18:55 +0100

dpkg (0.93.69) BETA; priority=MEDIUM

  * dpkg --configure and --remove should work properly when
    they have to defer processing (this tends to happen when many
    packages are processed at once).  (Bug#1209.)

  * dpkg --configure and --remove work better when `processing'
    several related packages with --no-act.

  * dpkg --auto is now two options, --pending or -a (for configure,
    remove, &c) and --recursive or -R (for install, unpack, &c).

  * dpkg debug options in usage message, and values available (-Dh).

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Wed, 9 Aug 1995 22:18:55 +0100

dpkg (0.93.68) BETA; priority=MEDIUM

  * dpkg won't get an internal error if you try to use the default
    conffiles response (ie, if you just hit return).  (Bug#1208.)

  * dselect hard disk and CD-ROM methods - the real thing, but ALPHA.

  * dselect allows you to go straight to `update' or `install' if
    you have already set up an access method.
  * new dpkg options --yet-to-unpack, --merge-avail and --update-avail.
  * dpkg -G is an abbreviation for dpkg --refuse-downgrade.
  * dpkg -R alias for --root withdrawn, pending reuse with different meaning.
  * dpkg --help message rationalised somewhat.

  * Obsolete `examples' and `dpkg-split' directories removed from
    source tree.  The `hello' package is a better example.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Mon, 7 Aug 1995 02:16:25 +0100

dpkg (0.93.67) BETA; priority=LOW for C dpkg alpha testers, HIGH for others

  * dpkg no longer statically linked and -g.
  * calls to abort() changed to print string, file and line number first.
  * removed unused variable from dpkg source.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Fri, 4 Aug 1995 01:39:52 +0100

dpkg (0.93.66) ALPHA; priority=MEDIUM

  * dpkg will correctly remove overwritten files from the lists of
    the package(s) that used to contain them.

  * dpkg --purge is now an action, rather than a modifier for --remove,
    and the -P alias for it is withdrawn.

  * dpkg --unpack/--install filenames in messages are now more sensible
    about when to use .../ (show as many trailing components as possible
    in 40 characters, or the whole path if that the last component is
    longer than that).

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Thu, 3 Aug 1995 02:11:03 +0100

dpkg (0.93.65) ALPHA; priority=MEDIUM

  * dpkg --remove should, when a package being removed is depended-on
    by another that is also queued for removal, defer the depended-on
    package rather than aborting it.  (Bug#1188.)

  * dpkg will not attempt to configure or remove a package more than
    once in the same run.  (Bug#1169.)

  * dpkg cosmetic fix to dependency problems message (this bug
    hasn't been triggered to my knowledge).

  * perl-dpkg no longer installed in /usr/bin.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Wed, 2 Aug 1995 13:02:58 +0100

dpkg (0.93.64) ALPHA; priority=MEDIUM

  * dpkg marks a package as no longer `to be configured in this run'
    when an error occurs, so that other packages which depend on it
    will fail (rather than causing a loop and an assertion failure,
     packages.c:166: failed assertion `dependtry <= 4').

  * dselect initial selection granularity is single-package.
  * dpkg --no-also-select option renamed to --selected-only (old option
    still accepted, but no longer in --help).  Changed -N to -O.

  * dselect `update' option changed to `install' (and other options
    renamed too).  NB: old access methods will not work, because
    the `update' script should now be an `install' script.

  * dselect `installation methods' renamed to `access methods'.
  * dpkg --skip-same-version and --refuse-downgrade produce friendlier
    messages when they skip packages.
  * --licence option now properly mentioned in all programs' --version
    messages.

  * bad fix for ELF compile problem involving myopt.h removed (compile
    problem turned out to be a GCC bug.)

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Tue, 1 Aug 1995 03:03:58 +0100

dpkg (0.93.63) ALPHA; priority=LOW

  * preinst works around shell bug/misfeature involving `trap'.

  * dpkg --skip-same-version doesn't skip packages which have
    an error flag set or which aren't in a standard `installed' state.

  * dpkg --search now does a substring search if the string doesn't
    start with a wildcard character (*, [ or ?) or slash.

  * problem with C/C++ linkage of stuff in "myopt.h" fixed, to help
    with compiling with GCC 2.7.0.

  * dselect Makefile.in `clean' deletes curkeys.inc &c, so that they are
    not shipped in the distribution source and will be rebuilt on the
    target system.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Thu, 27 Jul 1995 13:38:47 +0100

dpkg (0.93.62) ALPHA; priority=HIGH

  * dpkg purges leftover control scripts from /var/lib/dpkg/tmp.ci,
    rather than associating them with the wrong package.  (Bug#1101.)

  * dpkg won't `disappear' packages containing no files or directories,
    nor a package required for depends/recommended.  (Bug#1128.)

  * dpkg follows directory symlinks.  (Bug#1125.)

  * dselect fixups for ELF/GCC2.7.0 compilation.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Fri, 21 Jul 1995 21:43:41 +0100

dpkg (0.93.61) ALPHA; priority=LOW

  * dselect keybindings and status characters and descriptions changed
    (in pursuance of Bug#1037, user interface problems, still open.)

  * Some cleanups to fix mistakes discovered by ELF-GCC 2.7.0, and fixup
    for newer C++ draft standard (`for' variable declaration scope change).

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Tue, 18 Jul 1995 01:42:51 +0100

dpkg (0.93.60) ALPHA; priority=HIGH

  * dpkg doesn't think packages have `disappeared' if you install
    several packages at once.  (later reported as Bug#1132.)

  * usage error messages tidied up.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Sun, 16 Jul 1995 17:56:56 +0100

dpkg (0.93.59) ALPHA; priority=HIGH

  * dpkg doesn't break maintainer scripts &c if package `foo' exists
    when processing package `foobar'.  (Related to Bug#1101.)

  * dpkg implements `disappear' functionality.
  * dpkg/dselect remove dead entries from /var/lib/dpkg/status.

  * dpkg --list now sorted correctly and output somewhat improved.
  * some debugging messages moved from dbg_stupidlyverbose to dbg_scripts.
  * dpkg prints `Removing foo' message even if foo is not configured.
  * dpkg only prints `serious warning: files list file ... missing'
    once for each package.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Sun, 16 Jul 1995 02:32:11 +0100

dpkg (0.93.58) ALPHA; priority=HIGH

  * dpkg should write out status even for packages which it has only
    encountered in the `available' file so far.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Fri, 14 Jul 1995 20:19:21 +0100

dpkg (0.93.57) ALPHA; priority=LOW

  * dpkg does chroot when running maintainer scripts (--instdir
    should work right now, though I haven't been able to test it).

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Fri, 14 Jul 1995 01:32:30 +0100

dpkg (0.93.56) ALPHA; priority=HIGH

  * dpkg can now overwrite symlinks to directories, and will
    do correct handling of symlinks to plain files.
  * dpkg should not replace any directory with a symlink.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Thu, 13 Jul 1995 02:43:36 +0100

dpkg (0.93.55) ALPHA; priority=MEDIUM

  * dpkg can now extract hardlinks.
  * dpkg configuration/removal works in the presence of dependency cycles.
  * dpkg should no longer fail an assertion at processarc.c:193.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Wed, 12 Jul 1995 01:34:44 +0100

dpkg (0.93.54) ALPHA; priority=MEDIUM

  * dpkg and dselect no longer throw away all Class and Section
    information in /var/lib/dpkg/available.  (Oops.)
  * dpkg --refuse-<something> now works (this broke some dselect
    method scripts' attempts to use --refuse-downgrade).
  * dpkg --audit and --list implemented.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Mon, 10 Jul 1995 00:35:13 +0100

dpkg (0.93.53) ALPHA; priority=LOW

  * dpkg --install/--unpack only skips on-hold packages with --auto.
  * dpkg doesn't fclose() the --fsys-tarfile pipe twice.
  * dpkg error handling and reporting cleaned up.
  * dpkg now lists any failed packages/files just before exiting.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Sun, 9 Jul 1995 16:31:36 +0100

dpkg (0.93.52) ALPHA; priority=MEDIUM

  * dpkg won't segfault due to missing (Package_)Revision fields.
  * dpkg --search works.
  * dpkg will set execute permissions on scripts if necessary.
  * dpkg prints filenames in --unpack and --install.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Sat, 8 Jul 1995 12:41:39 +0100

dpkg (0.93.51) ALPHA; priority=HIGH

  * dpkg --status and --listfiles now work.

  * dpkg --remove --auto won't try to remove everything (!)
  * dpkg --unpack doesn't coredump after unpacking the first package.
  * dpkg won't fail an assertion if it bombs out of --configure
    or --remove because of too many errors.

  * Support for `Essential' in dpkg (not yet in dselect).
  * `available' (Packages) file class and section override those
    from package control files.
  * `Essential: yes' added to control file.

  * Locking strategy changed, now uses flock (no more stale locks).
  * preinst now more helpful about conffiles upgrade problem.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Sat, 8 Jul 1995 01:15:26 +0100

dpkg (0.93.50) ALPHA

  * C dpkg now in service.

  * dselect now installs in /usr/bin instead of /usr/sbin.
  * Improved `explanation of display' help and changed HSOC to EIOW.
  * dselect goes back to top of info display when you move the
    highlight.

  * Added <sys/types.h> to md5sum/md5.c, for the benefit of FreeBSD.
  * --admindir doesn't append `var/lib/dpkg' to its argument.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Fri, 19 May 1995 21:03:08 +0100

dpkg (0.93.42.3) BETA; priority=LOW

  * Rebuilt using ncurses 1.9.2c-0.
  * Silenced `subcritical error' message if errno == ENOENT.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Mon, 12 Jun 1995 13:09:24 +0100

dpkg (0.93.42.2) BETA; priority=HIGH

  * install-info --remove properly removes multi-line entries.
  * Slightly changed ^L redraw code in dselect package list.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Sat, 10 Jun 1995 14:06:01 +0100

dpkg (0.93.42.1) BETA; priority=HIGH esp. for new installations

  * update-rc.d default no longer adds K entries in runlevels 2345.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Tue, 6 Jun 1995 18:56:23 +0100

dpkg (0.93.42) BETA; priority=LOW; HIGH for dselect users

  * Fix unitialised variable reference bug in dselect (#890).
  * Fix problem with wordwrapping package and method descriptions.
  * Create /var/lib/dpkg/methods/mnt.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Fri, 19 May 1995 21:03:08 +0100

dpkg (0.93.41) BETA; priority=LOW

  * Create /var/lib/dpkg/methods.
  * dpkg.pl noisily ignores --skip-same-version rather than barfing.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Tue, 16 May 1995 13:28:27 +0100

dpkg (0.93.40) BETA; priority=LOW

  * dselect's subprogram failure message made to stand out more.

  * When switching out of curses, always move the cursor to the
    bottom right corner of the screen.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Tue, 16 May 1995 01:03:38 +0100

dpkg (0.93.39) BETA; priority=LOW

  * dselect can now:
    - allow you to select and configure an installation method;
    - invoke installation method scripts to update the available file
      and unpack packages;
    - invoke dpkg to configure and remove packages.
    There are no installation methods available yet.

  * Search feature in dselect works (it was purely an ncurses bug).

  * dpkg-*.nondebbin.tar.gz now available (built by debian.rules).

  * The target directory for dpkg-deb --extract (also available as
    dpkg --extract) is no longer optional.  dpkg-deb suggests the use
    of dpkg --install if you omit it.

  * Added <errno.h> to lib/lock.c and fixed ref. to `byte' in
    md5sum/md5.c, for portability to Solaris 2.

  * Rebuilt `configure' and `config.h.in' using autoconf 2.3.
  * Revised function attribute support checking in configure script.
  * Removed obsolete `dselect.pl' from scripts directory.
  * New option --licence on all the C programs.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Sun, 14 May 1995 18:05:38 +0100

dpkg (0.93.38) BETA; priority=MEDIUM

  * Version number comparisons (in dpkg and dselect) now >= <=
    as documented (Bug#831; thanks to Christian Linhart).

  * dselect now has a non-superuser readonly mode.
  * dselect doesn't pop up unsatisfied `Optional's when quitting.
  * `unable to delete saved old file' message fixed dpkg_tmp to dpkg-tmp.

  * Made dpkg convert `revision' to `package_revision' when reading
    (eg) the `status' file.  libdpkg.a has `revision' as a synonym
    for `package_revision' and writes the former.

  * Major improvements and many changes to C option parsing, database
    management, error handling, Makefiles &c to support dpkg.
  * dpkg-deb should now work if sizeof(void*) < sizeof(void(*)()).

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Mon, 24 Apr 1995 12:34:39 +0100

dpkg (0.93.37) BETA; priority=LOW (MEDIUM for dselect users)

  * Fixed segfault if no description available (Bug#735);
    thanks to Peter Tobias for the bug report.
  * Fixed other assorted minor bugs in description displays.

  * Changed dpkg-deb --info short option from -i to -I, to make
    it unique across dpkg and dpkg-deb (-i still works with
    dpkg-deb for backwards compatibility).

  * Produce more sensible error when main package list is empty.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Fri, 7 Apr 1995 02:24:55 +0100

dpkg (0.93.36) BETA; priority=LOW (MEDIUM for dselect users)

  * All the C code (including dselect) updated to support `provides'
    (virtual packages).
  * Revamped dselect's related package selection/deselection
    algorithms.
  * Everything can now handle arbitrary `class' values (as well
    as the predefined ones which we understand and can interpret).
  * Fixed bug that prevented display update when moving down a small
    recursive package list in dselect.
  * Column heading characters corrected from `SHOC' to `HSOC'.

 -- Ian Jackson <iwj10@cus.cam.ac.uk>  Thu, 6 Apr 1995 12:48:13 +0100

dpkg (0.93.35) BETA; priority=MEDIUM

 * Preserve ownerships and permissions on configuration files.
 * Fix bug in conffile updating that could leave a hardlink
   <foo>.dpkg-new to the conffile <foo>.

 * Improved dselect's package list help messages.
 * Highlight now moves on after (de)selecting just one package.
 * Better algorithm for scrolling up/down when moving highlight.
 * Fixed bug in display of `preformatted' extended Description lines.
   (dselect is still ALPHA, but is fairly stable.)

 * Improved dpkg's message when configuring a package that doesn't
   exist, and when selecting or skipping a package that isn't
   currently selected (during unpack processing).

 * Description in control file expanded.

 * Scroll back to top when changing what is in the `info' area.

dpkg (0.93.34) BETA; priority=LOW (HIGH for dselect users)

 * dselect: Fixed bug which caused a coredump if you exited the
   package list if you'd made any changes.  Ouch !

 * dselect: Improved selection algorithm to show fewer extraneous
   packages; improved display for unavailable packages.

 * dpkg: Improved progress messages during unpacking somewhat.

dpkg (0.93.33) BETA; priority=LOW (HIGH for dselect users)

 * dselect now has a main menu.

 * Fixed nasty uninitialised data bug in dselect.

 * dselect now locks and unlocks the packages database.

Mon, 27 Mar 1995 03:30:51 BST  Ian Jackson <iwj10@cus.cam.ac.uk>

	* dpkg (0.93.32): Alpha dselect released and installed in
	                  /usr/sbin/dselect.
	* dpkg (0.93.32): Many portability enhancements: should now
	                  compile using GCC 2.6.3, and dpkg-deb should
	                  compile better on non-Linux systems.
	* dpkg (0.93.32): dpkg will not loop if its stdin disappears
	                  and it needs to prompt.
	* dpkg (0.93.32): Fixed removal dependency error to show
	                  correct package (Bug #648).
	* dpkg (0.93.32): Tidied up copyright notices.
	* dpkg (0.93.32): First draft of update-rc.d manpage, not yet
	                  installed in /usr/man.
	* dpkg (0.93.32): Changes to top-level Makefile.in to improve
	                  error trapping.
	* dpkg (0.93.32): Improved Makefile `clean' and `distclean'
	                  targets.
	* dpkg (0.93.32): Deleted irrelevant `t.c' from lib and
	                  dselect directories.
	* dpkg (0.93.32): Added vercmp.c with version comparison code.
	* dpkg (0.93.32): varbufextend message changed - varbufs not
	                  just for input buffers.
	* dpkg (0.93.32): varbuf has C++ member functions in header
	                  #ifdef __cplusplus.

Changes in dpkg 0.93.31:

* start-stop-daemon --pidfile now works (Bug#571).
* Fixed dependency processing bugs which could require a rerun of
  dpkg --configure (Bug#566).
* Fixed garbage output for `language' of control file in dpkg-deb --info.

Changes in dpkg 0.93.30:

* Added /usr/sbin/start-stop-daemon.

Changes in dpkg 0.93.09:

* Made postinst scripts really be run when dpkg --purge used.
* Added new --force-extractfail option - VERY DANGEROUS.

Changes in dpkg 0.93.28:

* Removed undef of 0x_p21 in read_database_file, which caused the
  the whole status database to become trashed when any update files
  were read.
* Make infinite-loop prevention and cycle detection work.
* Made findbreakcycle work (ie, break properly when cycle detected).
* New script, update-rc.d, to update links /etc/rc?.d/[KS]??*.
* dpkg.pl now sets the umask to 022.
* Cosmetic error message fix to dpkg-deb.
* Deleted OLD directory altogether.
* Improved error-trapping in top-level Makefile loops.

Changes in dpkg 0.93.27:

* Make version number specifications in Depends &c work.
* Added AC_PROG_CXX to autoconf.in for dselect.
* Changed myopt.h not to have cipaction field in cmdinfo (this was
  specially for dpkg-deb) - now we have a generic void*.
* Renamed `class' member of `pkginfoperfile' to `clas' [sic].
* Much work in `dselect' subdirectory.
* Deleted executables, objects and libraries from OLD tree !
* Minor changes to various copyright notices and top-of-file comments.
* Don't install nasty Perl dselectish thing as /usr/bin/dselect.

Changes in dpkg 0.93.26:

* Added --no-also-select instead of not auto-selecting on --unpack
  but doing so on --install; removed --force-unpack-any.

Changes in dpkg 0.93.25:

* Fixed duplicate output (failure to flush before fork) bug.
* More clarification of md5sum.c copyright.
* Corrected typo in ChangeLog in 0.93.24 source package.

Changes in dpkg 0.93.24:

* dpkg could copy conffiles info from one package to another.  Aargh.
  Bug #426.
* dpkg failed to initialise status if you tried to remove or
  configure a nonexistent package.  Bug #419.
* install-info now handles START-INFO-DIR-ENTRY entries like:
   * Gdb::                         The GNU debugger.
  Previously it would only accept (Bug #407):
   * Gdb: (gdb).                   The GNU debugger.
* When installing a new foo.info[.gz], install-info now replaces
   * Foo: (foo.info).              The Gnoo Foo.
  as well as just * Foo: (foo). ...
* Moved option parsing out of dpkg-deb into libdpkg.
* Assorted minor source code rearrangements.
* Fixed assorted copyright notices, clarified md5sum copyright.
* Corrected typo in 0.93.23 source package's ChangeLog.

Changes in dpkg 0.93.23:

* `dpkg-deb' --build now does a syntax check on the control file.
* `dselect' is now no longer called `debian', spurious copy removed
  from package top-level source directory.
* C control information parsing complete and somewhat tested.
* Moved `global' include files into $(srcdir)/include from ../lib,
  added some files to the lib Makefile, and arranged for pop_cleanup().

Changes in dpkg 0.93.22:

* Fixed bug which caused dpkg to see failures of md5sum where there
  were none (would also have caused dpkg to miss a real failure).
* Fixed failure to update some `status' database fields.

Changes in dpkg 0.93.21:

* Fixed error-handling bug which could corrupt database.

Changes in dpkg 0.93.20:

* Fixed bug which ran old (/var/adm/dpkg) postinst scripts.
* Fixed dpkg usage message which claimed -i => both --install & --info.
* Use Colin Plumb's MD5 code - faster, and better copyright.
* Manpages: dpkg-deb(8), deb-control(5), deb(5) - thanks to Raul
  Deluth Miller.  Also, an xfig picture of some C program innards.

Changes in dpkg 0.93.19:

* Don't delete the `list' file from the dpkg database.
* Fixed various bugs in the conffile handling.
* Conffiles that are symlinks will now be treated as if the
  `dereferenced' name of the file was listed in conffiles.  This means
  that /etc/foo -> /usr/etc/foo will cause all conffile updates of
  /etc/foo to create /usr/etc/foo.dpkg-tmp &c instead.  However, the
  link will be removed if --purge is used to delete all the conffiles.
* When doing a new installation, or when updating a conffile that
  wasn't listed as a conffile in the old version of the package, don't
  do any prompting but just install the version from the archive.
* Corrected error message if exec of dpkg --vextract failed
  and --instroot or --root specified.
* Added new --force-unpack-any option.
* Extra newline after --status output.
* Added -W options to CFLAGS.
* Fixed mistake in previous ChangeLog entry.

Changes in dpkg 0.93.18:

* Fixed invocation of dpkg-deb --vextract if --root or --instdir
  not specified.
* Create /var/lib/dpkg/updates.

Changes in dpkg 0.93.17:

* install-info --remove exits with status 0 if it doesn't find the
  thing to remove, instead of status 1.
* Error handling functions have __attribute__((format...)) if GCC.
* push_cleanup its arg takes void **argv instead of char **argv.
* Top-level Makefile.in has set -e before `for' loops.
* dpkg-deb --info not-an-existing-file produces fewer error messages.

Changes in dpkg 0.93.16:

* Made --root= option really extract to $instroot instead of `/'.
* install-info clears the 0444 bits in its umask.
* Fixed a few database handling bugs which cause dpkg always to fail,
  and usually to corrupt the status database in various ways.
* dpkg-deb completely rewritten, now doesn't tinker with
  /var/{adm,lib}/dpkg.  Should be faster.
* Directory structure and Makefiles in source package reorganised.

Changes in dpkg 0.93.15:

* Added `debian' (dselect), still very primitive.
* Database format changed, and moved from /var/adm to /var/lib.
* Added dpkg --avail mode, --list, --status and --search.
* Set of dpkg => dpkg-deb pass-through operations changed (but
  dpkg-deb not yet updated).
* Added --root, --admindir and --instdir, as well as --isok &c.
* Moved much stuff into /usr/lib/dpkg-lib.pl, rewritten status
  database handling.
* Put packages in `purge' state even if `deinstall' requested if
  they have no postrm and no conffiles.
* Version number comparisons fixed.
* insert-version.pl now installes lib.pl filename too.
* Strip trailing slashes when reading files from file lists.

Changes in dpkg 0.93.14:

* Fixed parsing of DEPENDS &c fields with trailing whitespace.
* postinst now fixes up broken ispell.control file.
* Cyclic dependency/multiple package removal processing: don't consider
  packages we've just removed when looking for a reason not to go ahead.
* Added call to postinst with `purge' argument for expunging old
  configuration etc. that aren't listed in conffiles.

Changes in dpkg 0.93.13:

* sub S_ISREG defined in dpkg.pl.
* Checking of DEPENDS &c fields was too lax, causing an internal error
  if you fed it certain kinds of broken control file.
* Fixed misleading message from bogus installationstatus call.
* New -u and -U options to dpkg-deb which don't unpack the /DEBIAN
  directory, and use these in dpkg.pl; clean up /DEBIAN in postinst.

Changes in dpkg 0.93.12:

* No longer needs *.ph files, since these appear to be broken.
* Postinst fixes up *.control files with curly brackets.
* embryo of dselect.

Changes in dpkg 0.93.11:

* New --ignore-depends option.
* This ChangeLog changed format here.

Wed Nov 30 15:38:21 GMT 1994  Ian Jackson  <iwj10@cus.cam.ac.uk>

	* dpkg 0.93.11 released.

	* conffile updating fixed.

	* Message `updgrade' in dpkg changed to `replace'.

	* install-info now copes with multi-line entries.

	* version numbers now done automatically in dpkg and install-info.

	* more debugging around conffiles updates.

	* *.hash files not deleted so soon.

	* adds brand new packages to status array so we can install them.

	* postinst does h2ph for {sys,linux}/{stat,types}.ph if required.

Mon Nov 28 02:00:13 GMT 1994  Ian Jackson  <iwj10@cus.cam.ac.uk>

        * dpkg 0.93.10 released.

        * dpkg.pl completely rewritten.

        * dpkg-deb: removed dabase-processing and --install option.

        * Makefiles reworked, debian.rules added.

        * Don't install anything in /usr/doc/examples.

        * dpkg-*.deb contains /usr/bin/dpkg-deb.dist, fixed up by postinst.

Thu Oct 20 13:22:20 1994  Ian Murdock  (imurdock@debra.debian.org)

        * dpkg 0.93.9 released.

        * dpkg.pl: Use $argument, not $package, with `--build'.
        Make sure that saved postinst scripts are executable.

Tue Oct 18 09:40:57 1994  Ian Murdock  (imurdock@debra.debian.org)

        * dpkg 0.93.8 released.

        * deb/remove.c (pkg_remove): Do not report an error from rmdir ()
        when `errno' is ENOTEMPTY (Directory not empty), because in this
        case we have found the highest-level directory in the package and
        are ready to exit the loop (i.e., it is a normal occurrence).

Mon Oct 17 10:44:32 1994  Ian Murdock  (imurdock@debra.debian.org)

        * Makefile.in: Adapted all Makefiles to the GNU Coding Standards.

        * deb/remove.c (pkg_remove): Make sure that parent directories are
        removed LAST!  This will result in complete removal of packages
        when --remove is called.  dpkg 0.93.7 (and earlier) had problems
        with this because it tried to remove directories in order, which
        will work most of the time, but not necessarily all of the time.

        * deb/list.c (pkg_list): Output is sorted by package name.

Tue Oct  4 12:27:10 1994  Ian Murdock  (imurdock@debra.debian.org)

        * deb/contents.c (pkg_contents): When a list file cannot be
        opened, silently fail and let the front-end explain the problem.

        * deb/util.c (return_info): When a control file cannot be opened,
        silently fail and let the front-end explain the problem.

        * deb/search.c (pkg_search): Exit 0 if the regular expression is
        matched and 1 if it is not.

Mon Oct  3 18:38:53 1994  Ian Murdock  (imurdock@debra.debian.org)

        * dpkg.pl: New file.  Replaces dpkg.sh.

        * deb/Makefile.in: Renamed `dpkg-util.deb' to `dpkg-deb'.

        * deb/build.c (pkg_build): `--build' is less verbose, instead
        letting the front-end add verbosity where appropriate.

        * deb/install.c (pkg_install): Ditto.

        * deb/remove.c (pkg_remove): Ditto.

        * deb/search.c (pkg_search): Ditto.

        * deb/describe.c (pkg_describe): `--describe' is less verbose,
        instead letting the front-end add verbosity where appropriate.
        The ``Description:'' label has been removed.

        * deb/version.c (pkg_version): `--version' is less verbose,
        instead letting the front-end add verbosity where appropriate.
        The ``Version:'' label has been removed, as has the maintainer
        information.

Mon Sep 12 14:22:04 1994  Ian Murdock  (imurdock@debra.debian.org)

        * deb/version.c (pkg_version): `--version' now reports the
        version number of dpkg if no argument is specified.

Thu Sep  1 13:31:37 1994  Ian Murdock  (imurdock@debra.debian.org)

        * dpkg 0.93.7 released.

        * deb/build.c (pkg_build): check status and exit if non-zero.

        * deb/contents.c (pkg_contents): ditto.

        * deb/install.c (archive_extract): ditto.

Thu Sep  1 13:20:08 1994  Ian Murdock  (imurdock@debra.debian.org)

        * deb/version.c (pkg_version): indent to the same point as
        pkg_describe.

Thu Sep  1 12:21:11 1994  Ian Murdock  (imurdock@debra.debian.org)

        * Makefile.in (dist): added debian.rules binary, source and
        dist targets to make final distribution easier to make.
        (install): install programs to /usr/bin.

        * deb/Makefile.in (install): install programs to /usr/bin.

        * deb/list.c (pkg_list): enforce a maximum limit of ten characters
        for the package name in the output.
        (pkg_list): left-justify the version number to make it easier for
        the front-end to parse the output.
        (pkg_list): replace first '\n' character in packages[n].description
        with '\0'.

        * deb/install.c (archive_extract): use the `p' option to `tar' to
        ensure that permissions are preserved.

Sat Aug 27 09:53:37 1994  Ian Murdock  (imurdock@debra.debian.org)

        * dpkg 0.93.6 released.

        * deb/util.c (return_info): only unlink CONTROL if ARCHIVE_FLAG is
        true!

Fri Aug 26 15:38:22 1994  Ian Murdock  (imurdock@debra.debian.org)

        * dpkg 0.93.5 released.

        * deb/contents.c (pkg_contents): merged function archive_contents
        into function pkg_contents.

        * deb/contents.c (pkg_contents): use lstat (rather than stat) so
        that symbolic links are recognized.
        (pkg_contents): print the usual `<path> -> <link_to>' now that we
        recognize symbolic links.

        * deb/util.c (return_info): create a FIFO to pipe the needed
        information to the ``formatter'' rather than creating a directory
        in /tmp for the package information, which is what we used to do.

Thu Aug 25 11:46:27 1994  Ian Murdock  (imurdock@debra.debian.org)

        * lib/fake-ls.c (mk_date_string): return a pointer to malloc'ed
        area.
        (mk_mode_string): ditto.

        * dpkg.sh: make sure the control information is extracted to a
        uniquely-named temporary directory during package installation.

        * dpkg.sh: execute the pre- and post-removal scripts during
        package removal.

        * dpkg.sh: exit immediately if dpkg-util.deb reports failure.

        * deb/install.c (pkg_control): make sure that `package' exists and
        is a Debian archive before doing anything.

        * deb/install.c (pkg_extract): make sure that `package' exists and
        is a Debian archive before doing anything.

        * deb/install.c (pkg_install): unlink `extract_output' when done.

        * deb/remove.c (pkg_remove): use lstat (rather than stat) so that
        --remove does not get confused and think that a symbolic link to a
        directory is actually a directory, which results in the symbolic
        link never being removed at all.

ChangeLog begins Thu Aug 25 11:46:27 1994 for dpkg 0.93.5.

Local variables:
mode: debian-changelog
End:
